import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiManagementDiagnosticConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#always_log_errors ApiManagementDiagnostic#always_log_errors}.
     *
     * @stability stable
     */
    readonly alwaysLogErrors?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#api_management_logger_id ApiManagementDiagnostic#api_management_logger_id}.
     *
     * @stability stable
     */
    readonly apiManagementLoggerId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#api_management_name ApiManagementDiagnostic#api_management_name}.
     *
     * @stability stable
     */
    readonly apiManagementName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#enabled ApiManagementDiagnostic#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#http_correlation_protocol ApiManagementDiagnostic#http_correlation_protocol}.
     *
     * @stability stable
     */
    readonly httpCorrelationProtocol?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#identifier ApiManagementDiagnostic#identifier}.
     *
     * @stability stable
     */
    readonly identifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#log_client_ip ApiManagementDiagnostic#log_client_ip}.
     *
     * @stability stable
     */
    readonly logClientIp?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#resource_group_name ApiManagementDiagnostic#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#sampling_percentage ApiManagementDiagnostic#sampling_percentage}.
     *
     * @stability stable
     */
    readonly samplingPercentage?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#verbosity ApiManagementDiagnostic#verbosity}.
     *
     * @stability stable
     */
    readonly verbosity?: string;
    /**
     * backend_request block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#backend_request ApiManagementDiagnostic#backend_request}
     *
     * @stability stable
     */
    readonly backendRequest?: ApiManagementDiagnosticBackendRequest[];
    /**
     * backend_response block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#backend_response ApiManagementDiagnostic#backend_response}
     *
     * @stability stable
     */
    readonly backendResponse?: ApiManagementDiagnosticBackendResponse[];
    /**
     * frontend_request block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#frontend_request ApiManagementDiagnostic#frontend_request}
     *
     * @stability stable
     */
    readonly frontendRequest?: ApiManagementDiagnosticFrontendRequest[];
    /**
     * frontend_response block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#frontend_response ApiManagementDiagnostic#frontend_response}
     *
     * @stability stable
     */
    readonly frontendResponse?: ApiManagementDiagnosticFrontendResponse[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#timeouts ApiManagementDiagnostic#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ApiManagementDiagnosticTimeouts;
}
/**
 * @stability stable
 */
export interface ApiManagementDiagnosticBackendRequest {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#body_bytes ApiManagementDiagnostic#body_bytes}.
     *
     * @stability stable
     */
    readonly bodyBytes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#headers_to_log ApiManagementDiagnostic#headers_to_log}.
     *
     * @stability stable
     */
    readonly headersToLog?: string[];
}
/**
 * @stability stable
 */
export interface ApiManagementDiagnosticBackendResponse {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#body_bytes ApiManagementDiagnostic#body_bytes}.
     *
     * @stability stable
     */
    readonly bodyBytes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#headers_to_log ApiManagementDiagnostic#headers_to_log}.
     *
     * @stability stable
     */
    readonly headersToLog?: string[];
}
/**
 * @stability stable
 */
export interface ApiManagementDiagnosticFrontendRequest {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#body_bytes ApiManagementDiagnostic#body_bytes}.
     *
     * @stability stable
     */
    readonly bodyBytes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#headers_to_log ApiManagementDiagnostic#headers_to_log}.
     *
     * @stability stable
     */
    readonly headersToLog?: string[];
}
/**
 * @stability stable
 */
export interface ApiManagementDiagnosticFrontendResponse {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#body_bytes ApiManagementDiagnostic#body_bytes}.
     *
     * @stability stable
     */
    readonly bodyBytes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#headers_to_log ApiManagementDiagnostic#headers_to_log}.
     *
     * @stability stable
     */
    readonly headersToLog?: string[];
}
/**
 * @stability stable
 */
export interface ApiManagementDiagnosticTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#create ApiManagementDiagnostic#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#delete ApiManagementDiagnostic#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#read ApiManagementDiagnostic#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html#update ApiManagementDiagnostic#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html azurerm_api_management_diagnostic}.
 *
 * @stability stable
 */
export declare class ApiManagementDiagnostic extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_diagnostic.html azurerm_api_management_diagnostic} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiManagementDiagnosticConfig);
    private _alwaysLogErrors?;
    /**
     * @stability stable
     */
    get alwaysLogErrors(): boolean;
    /**
     * @stability stable
     */
    set alwaysLogErrors(value: boolean);
    /**
     * @stability stable
     */
    resetAlwaysLogErrors(): void;
    /**
     * @stability stable
     */
    get alwaysLogErrorsInput(): boolean | undefined;
    private _apiManagementLoggerId;
    /**
     * @stability stable
     */
    get apiManagementLoggerId(): string;
    /**
     * @stability stable
     */
    set apiManagementLoggerId(value: string);
    /**
     * @stability stable
     */
    get apiManagementLoggerIdInput(): string;
    private _apiManagementName;
    /**
     * @stability stable
     */
    get apiManagementName(): string;
    /**
     * @stability stable
     */
    set apiManagementName(value: string);
    /**
     * @stability stable
     */
    get apiManagementNameInput(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    private _httpCorrelationProtocol?;
    /**
     * @stability stable
     */
    get httpCorrelationProtocol(): string;
    /**
     * @stability stable
     */
    set httpCorrelationProtocol(value: string);
    /**
     * @stability stable
     */
    resetHttpCorrelationProtocol(): void;
    /**
     * @stability stable
     */
    get httpCorrelationProtocolInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _identifier;
    /**
     * @stability stable
     */
    get identifier(): string;
    /**
     * @stability stable
     */
    set identifier(value: string);
    /**
     * @stability stable
     */
    get identifierInput(): string;
    private _logClientIp?;
    /**
     * @stability stable
     */
    get logClientIp(): boolean;
    /**
     * @stability stable
     */
    set logClientIp(value: boolean);
    /**
     * @stability stable
     */
    resetLogClientIp(): void;
    /**
     * @stability stable
     */
    get logClientIpInput(): boolean | undefined;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _samplingPercentage?;
    /**
     * @stability stable
     */
    get samplingPercentage(): number;
    /**
     * @stability stable
     */
    set samplingPercentage(value: number);
    /**
     * @stability stable
     */
    resetSamplingPercentage(): void;
    /**
     * @stability stable
     */
    get samplingPercentageInput(): number | undefined;
    private _verbosity?;
    /**
     * @stability stable
     */
    get verbosity(): string;
    /**
     * @stability stable
     */
    set verbosity(value: string);
    /**
     * @stability stable
     */
    resetVerbosity(): void;
    /**
     * @stability stable
     */
    get verbosityInput(): string | undefined;
    private _backendRequest?;
    /**
     * @stability stable
     */
    get backendRequest(): ApiManagementDiagnosticBackendRequest[];
    /**
     * @stability stable
     */
    set backendRequest(value: ApiManagementDiagnosticBackendRequest[]);
    /**
     * @stability stable
     */
    resetBackendRequest(): void;
    /**
     * @stability stable
     */
    get backendRequestInput(): ApiManagementDiagnosticBackendRequest[] | undefined;
    private _backendResponse?;
    /**
     * @stability stable
     */
    get backendResponse(): ApiManagementDiagnosticBackendResponse[];
    /**
     * @stability stable
     */
    set backendResponse(value: ApiManagementDiagnosticBackendResponse[]);
    /**
     * @stability stable
     */
    resetBackendResponse(): void;
    /**
     * @stability stable
     */
    get backendResponseInput(): ApiManagementDiagnosticBackendResponse[] | undefined;
    private _frontendRequest?;
    /**
     * @stability stable
     */
    get frontendRequest(): ApiManagementDiagnosticFrontendRequest[];
    /**
     * @stability stable
     */
    set frontendRequest(value: ApiManagementDiagnosticFrontendRequest[]);
    /**
     * @stability stable
     */
    resetFrontendRequest(): void;
    /**
     * @stability stable
     */
    get frontendRequestInput(): ApiManagementDiagnosticFrontendRequest[] | undefined;
    private _frontendResponse?;
    /**
     * @stability stable
     */
    get frontendResponse(): ApiManagementDiagnosticFrontendResponse[];
    /**
     * @stability stable
     */
    set frontendResponse(value: ApiManagementDiagnosticFrontendResponse[]);
    /**
     * @stability stable
     */
    resetFrontendResponse(): void;
    /**
     * @stability stable
     */
    get frontendResponseInput(): ApiManagementDiagnosticFrontendResponse[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): ApiManagementDiagnosticTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: ApiManagementDiagnosticTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ApiManagementDiagnosticTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
