import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppServiceCertificateBindingConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_certificate_binding.html#certificate_id AppServiceCertificateBinding#certificate_id}.
     *
     * @stability stable
     */
    readonly certificateId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_certificate_binding.html#hostname_binding_id AppServiceCertificateBinding#hostname_binding_id}.
     *
     * @stability stable
     */
    readonly hostnameBindingId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_certificate_binding.html#ssl_state AppServiceCertificateBinding#ssl_state}.
     *
     * @stability stable
     */
    readonly sslState: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_certificate_binding.html#timeouts AppServiceCertificateBinding#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: AppServiceCertificateBindingTimeouts;
}
/**
 * @stability stable
 */
export interface AppServiceCertificateBindingTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_certificate_binding.html#create AppServiceCertificateBinding#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_certificate_binding.html#delete AppServiceCertificateBinding#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_certificate_binding.html#read AppServiceCertificateBinding#read}.
     *
     * @stability stable
     */
    readonly read?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_certificate_binding.html azurerm_app_service_certificate_binding}.
 *
 * @stability stable
 */
export declare class AppServiceCertificateBinding extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_certificate_binding.html azurerm_app_service_certificate_binding} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppServiceCertificateBindingConfig);
    /**
     * @stability stable
     */
    get appServiceName(): string;
    private _certificateId;
    /**
     * @stability stable
     */
    get certificateId(): string;
    /**
     * @stability stable
     */
    set certificateId(value: string);
    /**
     * @stability stable
     */
    get certificateIdInput(): string;
    /**
     * @stability stable
     */
    get hostname(): string;
    private _hostnameBindingId;
    /**
     * @stability stable
     */
    get hostnameBindingId(): string;
    /**
     * @stability stable
     */
    set hostnameBindingId(value: string);
    /**
     * @stability stable
     */
    get hostnameBindingIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _sslState;
    /**
     * @stability stable
     */
    get sslState(): string;
    /**
     * @stability stable
     */
    set sslState(value: string);
    /**
     * @stability stable
     */
    get sslStateInput(): string;
    /**
     * @stability stable
     */
    get thumbprint(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): AppServiceCertificateBindingTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: AppServiceCertificateBindingTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): AppServiceCertificateBindingTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
