import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppServiceVirtualNetworkSwiftConnectionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_virtual_network_swift_connection.html#app_service_id AppServiceVirtualNetworkSwiftConnection#app_service_id}.
     *
     * @stability stable
     */
    readonly appServiceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_virtual_network_swift_connection.html#subnet_id AppServiceVirtualNetworkSwiftConnection#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_virtual_network_swift_connection.html#timeouts AppServiceVirtualNetworkSwiftConnection#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: AppServiceVirtualNetworkSwiftConnectionTimeouts;
}
/**
 * @stability stable
 */
export interface AppServiceVirtualNetworkSwiftConnectionTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_virtual_network_swift_connection.html#create AppServiceVirtualNetworkSwiftConnection#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_virtual_network_swift_connection.html#delete AppServiceVirtualNetworkSwiftConnection#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_virtual_network_swift_connection.html#read AppServiceVirtualNetworkSwiftConnection#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_virtual_network_swift_connection.html#update AppServiceVirtualNetworkSwiftConnection#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_virtual_network_swift_connection.html azurerm_app_service_virtual_network_swift_connection}.
 *
 * @stability stable
 */
export declare class AppServiceVirtualNetworkSwiftConnection extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/app_service_virtual_network_swift_connection.html azurerm_app_service_virtual_network_swift_connection} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppServiceVirtualNetworkSwiftConnectionConfig);
    private _appServiceId;
    /**
     * @stability stable
     */
    get appServiceId(): string;
    /**
     * @stability stable
     */
    set appServiceId(value: string);
    /**
     * @stability stable
     */
    get appServiceIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _subnetId;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    get subnetIdInput(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): AppServiceVirtualNetworkSwiftConnectionTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: AppServiceVirtualNetworkSwiftConnectionTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): AppServiceVirtualNetworkSwiftConnectionTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
