import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface BackupPolicyFileShareConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#name BackupPolicyFileShare#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#recovery_vault_name BackupPolicyFileShare#recovery_vault_name}.
     *
     * @stability stable
     */
    readonly recoveryVaultName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#resource_group_name BackupPolicyFileShare#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#tags BackupPolicyFileShare#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#timezone BackupPolicyFileShare#timezone}.
     *
     * @stability stable
     */
    readonly timezone?: string;
    /**
     * backup block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#backup BackupPolicyFileShare#backup}
     *
     * @stability stable
     */
    readonly backup: BackupPolicyFileShareBackup[];
    /**
     * retention_daily block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#retention_daily BackupPolicyFileShare#retention_daily}
     *
     * @stability stable
     */
    readonly retentionDaily: BackupPolicyFileShareRetentionDaily[];
    /**
     * retention_monthly block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#retention_monthly BackupPolicyFileShare#retention_monthly}
     *
     * @stability stable
     */
    readonly retentionMonthly?: BackupPolicyFileShareRetentionMonthly[];
    /**
     * retention_weekly block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#retention_weekly BackupPolicyFileShare#retention_weekly}
     *
     * @stability stable
     */
    readonly retentionWeekly?: BackupPolicyFileShareRetentionWeekly[];
    /**
     * retention_yearly block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#retention_yearly BackupPolicyFileShare#retention_yearly}
     *
     * @stability stable
     */
    readonly retentionYearly?: BackupPolicyFileShareRetentionYearly[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#timeouts BackupPolicyFileShare#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: BackupPolicyFileShareTimeouts;
}
/**
 * @stability stable
 */
export interface BackupPolicyFileShareBackup {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#frequency BackupPolicyFileShare#frequency}.
     *
     * @stability stable
     */
    readonly frequency: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#time BackupPolicyFileShare#time}.
     *
     * @stability stable
     */
    readonly time: string;
}
/**
 * @stability stable
 */
export interface BackupPolicyFileShareRetentionDaily {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#count BackupPolicyFileShare#count}.
     *
     * @stability stable
     */
    readonly count: number;
}
/**
 * @stability stable
 */
export interface BackupPolicyFileShareRetentionMonthly {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#count BackupPolicyFileShare#count}.
     *
     * @stability stable
     */
    readonly count: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#weekdays BackupPolicyFileShare#weekdays}.
     *
     * @stability stable
     */
    readonly weekdays: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#weeks BackupPolicyFileShare#weeks}.
     *
     * @stability stable
     */
    readonly weeks: string[];
}
/**
 * @stability stable
 */
export interface BackupPolicyFileShareRetentionWeekly {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#count BackupPolicyFileShare#count}.
     *
     * @stability stable
     */
    readonly count: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#weekdays BackupPolicyFileShare#weekdays}.
     *
     * @stability stable
     */
    readonly weekdays: string[];
}
/**
 * @stability stable
 */
export interface BackupPolicyFileShareRetentionYearly {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#count BackupPolicyFileShare#count}.
     *
     * @stability stable
     */
    readonly count: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#months BackupPolicyFileShare#months}.
     *
     * @stability stable
     */
    readonly months: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#weekdays BackupPolicyFileShare#weekdays}.
     *
     * @stability stable
     */
    readonly weekdays: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#weeks BackupPolicyFileShare#weeks}.
     *
     * @stability stable
     */
    readonly weeks: string[];
}
/**
 * @stability stable
 */
export interface BackupPolicyFileShareTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#create BackupPolicyFileShare#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#delete BackupPolicyFileShare#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#read BackupPolicyFileShare#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html#update BackupPolicyFileShare#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html azurerm_backup_policy_file_share}.
 *
 * @stability stable
 */
export declare class BackupPolicyFileShare extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_file_share.html azurerm_backup_policy_file_share} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BackupPolicyFileShareConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _recoveryVaultName;
    /**
     * @stability stable
     */
    get recoveryVaultName(): string;
    /**
     * @stability stable
     */
    set recoveryVaultName(value: string);
    /**
     * @stability stable
     */
    get recoveryVaultNameInput(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _timezone?;
    /**
     * @stability stable
     */
    get timezone(): string;
    /**
     * @stability stable
     */
    set timezone(value: string);
    /**
     * @stability stable
     */
    resetTimezone(): void;
    /**
     * @stability stable
     */
    get timezoneInput(): string | undefined;
    private _backup;
    /**
     * @stability stable
     */
    get backup(): BackupPolicyFileShareBackup[];
    /**
     * @stability stable
     */
    set backup(value: BackupPolicyFileShareBackup[]);
    /**
     * @stability stable
     */
    get backupInput(): BackupPolicyFileShareBackup[];
    private _retentionDaily;
    /**
     * @stability stable
     */
    get retentionDaily(): BackupPolicyFileShareRetentionDaily[];
    /**
     * @stability stable
     */
    set retentionDaily(value: BackupPolicyFileShareRetentionDaily[]);
    /**
     * @stability stable
     */
    get retentionDailyInput(): BackupPolicyFileShareRetentionDaily[];
    private _retentionMonthly?;
    /**
     * @stability stable
     */
    get retentionMonthly(): BackupPolicyFileShareRetentionMonthly[];
    /**
     * @stability stable
     */
    set retentionMonthly(value: BackupPolicyFileShareRetentionMonthly[]);
    /**
     * @stability stable
     */
    resetRetentionMonthly(): void;
    /**
     * @stability stable
     */
    get retentionMonthlyInput(): BackupPolicyFileShareRetentionMonthly[] | undefined;
    private _retentionWeekly?;
    /**
     * @stability stable
     */
    get retentionWeekly(): BackupPolicyFileShareRetentionWeekly[];
    /**
     * @stability stable
     */
    set retentionWeekly(value: BackupPolicyFileShareRetentionWeekly[]);
    /**
     * @stability stable
     */
    resetRetentionWeekly(): void;
    /**
     * @stability stable
     */
    get retentionWeeklyInput(): BackupPolicyFileShareRetentionWeekly[] | undefined;
    private _retentionYearly?;
    /**
     * @stability stable
     */
    get retentionYearly(): BackupPolicyFileShareRetentionYearly[];
    /**
     * @stability stable
     */
    set retentionYearly(value: BackupPolicyFileShareRetentionYearly[]);
    /**
     * @stability stable
     */
    resetRetentionYearly(): void;
    /**
     * @stability stable
     */
    get retentionYearlyInput(): BackupPolicyFileShareRetentionYearly[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): BackupPolicyFileShareTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: BackupPolicyFileShareTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): BackupPolicyFileShareTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
