import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface BackupPolicyVmConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#instant_restore_retention_days BackupPolicyVm#instant_restore_retention_days}.
     *
     * @stability stable
     */
    readonly instantRestoreRetentionDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#name BackupPolicyVm#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#recovery_vault_name BackupPolicyVm#recovery_vault_name}.
     *
     * @stability stable
     */
    readonly recoveryVaultName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#resource_group_name BackupPolicyVm#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#tags BackupPolicyVm#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#timezone BackupPolicyVm#timezone}.
     *
     * @stability stable
     */
    readonly timezone?: string;
    /**
     * backup block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#backup BackupPolicyVm#backup}
     *
     * @stability stable
     */
    readonly backup: BackupPolicyVmBackup[];
    /**
     * retention_daily block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#retention_daily BackupPolicyVm#retention_daily}
     *
     * @stability stable
     */
    readonly retentionDaily?: BackupPolicyVmRetentionDaily[];
    /**
     * retention_monthly block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#retention_monthly BackupPolicyVm#retention_monthly}
     *
     * @stability stable
     */
    readonly retentionMonthly?: BackupPolicyVmRetentionMonthly[];
    /**
     * retention_weekly block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#retention_weekly BackupPolicyVm#retention_weekly}
     *
     * @stability stable
     */
    readonly retentionWeekly?: BackupPolicyVmRetentionWeekly[];
    /**
     * retention_yearly block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#retention_yearly BackupPolicyVm#retention_yearly}
     *
     * @stability stable
     */
    readonly retentionYearly?: BackupPolicyVmRetentionYearly[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#timeouts BackupPolicyVm#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: BackupPolicyVmTimeouts;
}
/**
 * @stability stable
 */
export interface BackupPolicyVmBackup {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#frequency BackupPolicyVm#frequency}.
     *
     * @stability stable
     */
    readonly frequency: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#time BackupPolicyVm#time}.
     *
     * @stability stable
     */
    readonly time: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#weekdays BackupPolicyVm#weekdays}.
     *
     * @stability stable
     */
    readonly weekdays?: string[];
}
/**
 * @stability stable
 */
export interface BackupPolicyVmRetentionDaily {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#count BackupPolicyVm#count}.
     *
     * @stability stable
     */
    readonly count: number;
}
/**
 * @stability stable
 */
export interface BackupPolicyVmRetentionMonthly {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#count BackupPolicyVm#count}.
     *
     * @stability stable
     */
    readonly count: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#weekdays BackupPolicyVm#weekdays}.
     *
     * @stability stable
     */
    readonly weekdays: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#weeks BackupPolicyVm#weeks}.
     *
     * @stability stable
     */
    readonly weeks: string[];
}
/**
 * @stability stable
 */
export interface BackupPolicyVmRetentionWeekly {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#count BackupPolicyVm#count}.
     *
     * @stability stable
     */
    readonly count: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#weekdays BackupPolicyVm#weekdays}.
     *
     * @stability stable
     */
    readonly weekdays: string[];
}
/**
 * @stability stable
 */
export interface BackupPolicyVmRetentionYearly {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#count BackupPolicyVm#count}.
     *
     * @stability stable
     */
    readonly count: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#months BackupPolicyVm#months}.
     *
     * @stability stable
     */
    readonly months: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#weekdays BackupPolicyVm#weekdays}.
     *
     * @stability stable
     */
    readonly weekdays: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#weeks BackupPolicyVm#weeks}.
     *
     * @stability stable
     */
    readonly weeks: string[];
}
/**
 * @stability stable
 */
export interface BackupPolicyVmTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#create BackupPolicyVm#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#delete BackupPolicyVm#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#read BackupPolicyVm#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html#update BackupPolicyVm#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html azurerm_backup_policy_vm}.
 *
 * @stability stable
 */
export declare class BackupPolicyVm extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/backup_policy_vm.html azurerm_backup_policy_vm} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BackupPolicyVmConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _instantRestoreRetentionDays?;
    /**
     * @stability stable
     */
    get instantRestoreRetentionDays(): number;
    /**
     * @stability stable
     */
    set instantRestoreRetentionDays(value: number);
    /**
     * @stability stable
     */
    resetInstantRestoreRetentionDays(): void;
    /**
     * @stability stable
     */
    get instantRestoreRetentionDaysInput(): number | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _recoveryVaultName;
    /**
     * @stability stable
     */
    get recoveryVaultName(): string;
    /**
     * @stability stable
     */
    set recoveryVaultName(value: string);
    /**
     * @stability stable
     */
    get recoveryVaultNameInput(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _timezone?;
    /**
     * @stability stable
     */
    get timezone(): string;
    /**
     * @stability stable
     */
    set timezone(value: string);
    /**
     * @stability stable
     */
    resetTimezone(): void;
    /**
     * @stability stable
     */
    get timezoneInput(): string | undefined;
    private _backup;
    /**
     * @stability stable
     */
    get backup(): BackupPolicyVmBackup[];
    /**
     * @stability stable
     */
    set backup(value: BackupPolicyVmBackup[]);
    /**
     * @stability stable
     */
    get backupInput(): BackupPolicyVmBackup[];
    private _retentionDaily?;
    /**
     * @stability stable
     */
    get retentionDaily(): BackupPolicyVmRetentionDaily[];
    /**
     * @stability stable
     */
    set retentionDaily(value: BackupPolicyVmRetentionDaily[]);
    /**
     * @stability stable
     */
    resetRetentionDaily(): void;
    /**
     * @stability stable
     */
    get retentionDailyInput(): BackupPolicyVmRetentionDaily[] | undefined;
    private _retentionMonthly?;
    /**
     * @stability stable
     */
    get retentionMonthly(): BackupPolicyVmRetentionMonthly[];
    /**
     * @stability stable
     */
    set retentionMonthly(value: BackupPolicyVmRetentionMonthly[]);
    /**
     * @stability stable
     */
    resetRetentionMonthly(): void;
    /**
     * @stability stable
     */
    get retentionMonthlyInput(): BackupPolicyVmRetentionMonthly[] | undefined;
    private _retentionWeekly?;
    /**
     * @stability stable
     */
    get retentionWeekly(): BackupPolicyVmRetentionWeekly[];
    /**
     * @stability stable
     */
    set retentionWeekly(value: BackupPolicyVmRetentionWeekly[]);
    /**
     * @stability stable
     */
    resetRetentionWeekly(): void;
    /**
     * @stability stable
     */
    get retentionWeeklyInput(): BackupPolicyVmRetentionWeekly[] | undefined;
    private _retentionYearly?;
    /**
     * @stability stable
     */
    get retentionYearly(): BackupPolicyVmRetentionYearly[];
    /**
     * @stability stable
     */
    set retentionYearly(value: BackupPolicyVmRetentionYearly[]);
    /**
     * @stability stable
     */
    resetRetentionYearly(): void;
    /**
     * @stability stable
     */
    get retentionYearlyInput(): BackupPolicyVmRetentionYearly[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): BackupPolicyVmTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: BackupPolicyVmTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): BackupPolicyVmTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
