import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CosmosdbGremlinGraphConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#account_name CosmosdbGremlinGraph#account_name}.
     *
     * @stability stable
     */
    readonly accountName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#database_name CosmosdbGremlinGraph#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#default_ttl CosmosdbGremlinGraph#default_ttl}.
     *
     * @stability stable
     */
    readonly defaultTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#name CosmosdbGremlinGraph#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#partition_key_path CosmosdbGremlinGraph#partition_key_path}.
     *
     * @stability stable
     */
    readonly partitionKeyPath: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#resource_group_name CosmosdbGremlinGraph#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#throughput CosmosdbGremlinGraph#throughput}.
     *
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * autoscale_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#autoscale_settings CosmosdbGremlinGraph#autoscale_settings}
     *
     * @stability stable
     */
    readonly autoscaleSettings?: CosmosdbGremlinGraphAutoscaleSettings[];
    /**
     * conflict_resolution_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#conflict_resolution_policy CosmosdbGremlinGraph#conflict_resolution_policy}
     *
     * @stability stable
     */
    readonly conflictResolutionPolicy?: CosmosdbGremlinGraphConflictResolutionPolicy[];
    /**
     * index_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#index_policy CosmosdbGremlinGraph#index_policy}
     *
     * @stability stable
     */
    readonly indexPolicy: CosmosdbGremlinGraphIndexPolicy[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#timeouts CosmosdbGremlinGraph#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: CosmosdbGremlinGraphTimeouts;
    /**
     * unique_key block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#unique_key CosmosdbGremlinGraph#unique_key}
     *
     * @stability stable
     */
    readonly uniqueKey?: CosmosdbGremlinGraphUniqueKey[];
}
/**
 * @stability stable
 */
export interface CosmosdbGremlinGraphAutoscaleSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#max_throughput CosmosdbGremlinGraph#max_throughput}.
     *
     * @stability stable
     */
    readonly maxThroughput?: number;
}
/**
 * @stability stable
 */
export interface CosmosdbGremlinGraphConflictResolutionPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#conflict_resolution_path CosmosdbGremlinGraph#conflict_resolution_path}.
     *
     * @stability stable
     */
    readonly conflictResolutionPath?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#conflict_resolution_procedure CosmosdbGremlinGraph#conflict_resolution_procedure}.
     *
     * @stability stable
     */
    readonly conflictResolutionProcedure?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#mode CosmosdbGremlinGraph#mode}.
     *
     * @stability stable
     */
    readonly mode: string;
}
/**
 * @stability stable
 */
export interface CosmosdbGremlinGraphIndexPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#automatic CosmosdbGremlinGraph#automatic}.
     *
     * @stability stable
     */
    readonly automatic?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#excluded_paths CosmosdbGremlinGraph#excluded_paths}.
     *
     * @stability stable
     */
    readonly excludedPaths?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#included_paths CosmosdbGremlinGraph#included_paths}.
     *
     * @stability stable
     */
    readonly includedPaths?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#indexing_mode CosmosdbGremlinGraph#indexing_mode}.
     *
     * @stability stable
     */
    readonly indexingMode: string;
}
/**
 * @stability stable
 */
export interface CosmosdbGremlinGraphTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#create CosmosdbGremlinGraph#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#delete CosmosdbGremlinGraph#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#read CosmosdbGremlinGraph#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#update CosmosdbGremlinGraph#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export interface CosmosdbGremlinGraphUniqueKey {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html#paths CosmosdbGremlinGraph#paths}.
     *
     * @stability stable
     */
    readonly paths: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html azurerm_cosmosdb_gremlin_graph}.
 *
 * @stability stable
 */
export declare class CosmosdbGremlinGraph extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/cosmosdb_gremlin_graph.html azurerm_cosmosdb_gremlin_graph} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CosmosdbGremlinGraphConfig);
    private _accountName;
    /**
     * @stability stable
     */
    get accountName(): string;
    /**
     * @stability stable
     */
    set accountName(value: string);
    /**
     * @stability stable
     */
    get accountNameInput(): string;
    private _databaseName;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    get databaseNameInput(): string;
    private _defaultTtl?;
    /**
     * @stability stable
     */
    get defaultTtl(): number;
    /**
     * @stability stable
     */
    set defaultTtl(value: number);
    /**
     * @stability stable
     */
    resetDefaultTtl(): void;
    /**
     * @stability stable
     */
    get defaultTtlInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _partitionKeyPath;
    /**
     * @stability stable
     */
    get partitionKeyPath(): string;
    /**
     * @stability stable
     */
    set partitionKeyPath(value: string);
    /**
     * @stability stable
     */
    get partitionKeyPathInput(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _throughput?;
    /**
     * @stability stable
     */
    get throughput(): number;
    /**
     * @stability stable
     */
    set throughput(value: number);
    /**
     * @stability stable
     */
    resetThroughput(): void;
    /**
     * @stability stable
     */
    get throughputInput(): number | undefined;
    private _autoscaleSettings?;
    /**
     * @stability stable
     */
    get autoscaleSettings(): CosmosdbGremlinGraphAutoscaleSettings[];
    /**
     * @stability stable
     */
    set autoscaleSettings(value: CosmosdbGremlinGraphAutoscaleSettings[]);
    /**
     * @stability stable
     */
    resetAutoscaleSettings(): void;
    /**
     * @stability stable
     */
    get autoscaleSettingsInput(): CosmosdbGremlinGraphAutoscaleSettings[] | undefined;
    private _conflictResolutionPolicy?;
    /**
     * @stability stable
     */
    get conflictResolutionPolicy(): CosmosdbGremlinGraphConflictResolutionPolicy[];
    /**
     * @stability stable
     */
    set conflictResolutionPolicy(value: CosmosdbGremlinGraphConflictResolutionPolicy[]);
    /**
     * @stability stable
     */
    resetConflictResolutionPolicy(): void;
    /**
     * @stability stable
     */
    get conflictResolutionPolicyInput(): CosmosdbGremlinGraphConflictResolutionPolicy[] | undefined;
    private _indexPolicy;
    /**
     * @stability stable
     */
    get indexPolicy(): CosmosdbGremlinGraphIndexPolicy[];
    /**
     * @stability stable
     */
    set indexPolicy(value: CosmosdbGremlinGraphIndexPolicy[]);
    /**
     * @stability stable
     */
    get indexPolicyInput(): CosmosdbGremlinGraphIndexPolicy[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): CosmosdbGremlinGraphTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: CosmosdbGremlinGraphTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): CosmosdbGremlinGraphTimeouts | undefined;
    private _uniqueKey?;
    /**
     * @stability stable
     */
    get uniqueKey(): CosmosdbGremlinGraphUniqueKey[];
    /**
     * @stability stable
     */
    set uniqueKey(value: CosmosdbGremlinGraphUniqueKey[]);
    /**
     * @stability stable
     */
    resetUniqueKey(): void;
    /**
     * @stability stable
     */
    get uniqueKeyInput(): CosmosdbGremlinGraphUniqueKey[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
