import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAzurermCosmosdbAccountConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/cosmosdb_account.html#name DataAzurermCosmosdbAccount#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/cosmosdb_account.html#resource_group_name DataAzurermCosmosdbAccount#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/cosmosdb_account.html#timeouts DataAzurermCosmosdbAccount#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DataAzurermCosmosdbAccountTimeouts;
}
/**
 * @stability stable
 */
export declare class DataAzurermCosmosdbAccountCapabilities extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get name(): string;
}
/**
 * @stability stable
 */
export declare class DataAzurermCosmosdbAccountConsistencyPolicy extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get consistencyLevel(): string;
    /**
     * @stability stable
     */
    get maxIntervalInSeconds(): number;
    /**
     * @stability stable
     */
    get maxStalenessPrefix(): number;
}
/**
 * @stability stable
 */
export declare class DataAzurermCosmosdbAccountGeoLocation extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get failoverPriority(): number;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get location(): string;
}
/**
 * @stability stable
 */
export declare class DataAzurermCosmosdbAccountVirtualNetworkRule extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get id(): string;
}
/**
 * @stability stable
 */
export interface DataAzurermCosmosdbAccountTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/cosmosdb_account.html#read DataAzurermCosmosdbAccount#read}.
     *
     * @stability stable
     */
    readonly read?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/d/cosmosdb_account.html azurerm_cosmosdb_account}.
 *
 * @stability stable
 */
export declare class DataAzurermCosmosdbAccount extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/d/cosmosdb_account.html azurerm_cosmosdb_account} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAzurermCosmosdbAccountConfig);
    /**
     * @stability stable
     */
    capabilities(index: string): DataAzurermCosmosdbAccountCapabilities;
    /**
     * @stability stable
     */
    consistencyPolicy(index: string): DataAzurermCosmosdbAccountConsistencyPolicy;
    /**
     * @stability stable
     */
    get enableAutomaticFailover(): boolean;
    /**
     * @stability stable
     */
    get enableFreeTier(): boolean;
    /**
     * @stability stable
     */
    get enableMultipleWriteLocations(): boolean;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    geoLocation(index: string): DataAzurermCosmosdbAccountGeoLocation;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ipRangeFilter(): string;
    /**
     * @stability stable
     */
    get isVirtualNetworkFilterEnabled(): boolean;
    /**
     * @stability stable
     */
    get keyVaultKeyId(): string;
    /**
     * @stability stable
     */
    get kind(): string;
    /**
     * @stability stable
     */
    get location(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get offerType(): string;
    /**
     * @stability stable
     */
    get primaryKey(): string;
    /**
     * @stability stable
     */
    get primaryMasterKey(): string;
    /**
     * @stability stable
     */
    get primaryReadonlyKey(): string;
    /**
     * @stability stable
     */
    get primaryReadonlyMasterKey(): string;
    /**
     * @stability stable
     */
    get readEndpoints(): string[];
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    /**
     * @stability stable
     */
    get secondaryKey(): string;
    /**
     * @stability stable
     */
    get secondaryMasterKey(): string;
    /**
     * @stability stable
     */
    get secondaryReadonlyKey(): string;
    /**
     * @stability stable
     */
    get secondaryReadonlyMasterKey(): string;
    /**
     * @stability stable
     */
    tags(key: string): string;
    /**
     * @stability stable
     */
    virtualNetworkRule(index: string): DataAzurermCosmosdbAccountVirtualNetworkRule;
    /**
     * @stability stable
     */
    get writeEndpoints(): string[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DataAzurermCosmosdbAccountTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DataAzurermCosmosdbAccountTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DataAzurermCosmosdbAccountTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
