import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAzurermHealthcareServiceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/healthcare_service.html#location DataAzurermHealthcareService#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/healthcare_service.html#name DataAzurermHealthcareService#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/healthcare_service.html#resource_group_name DataAzurermHealthcareService#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/healthcare_service.html#timeouts DataAzurermHealthcareService#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DataAzurermHealthcareServiceTimeouts;
}
/**
 * @stability stable
 */
export declare class DataAzurermHealthcareServiceAuthenticationConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get audience(): string;
    /**
     * @stability stable
     */
    get authority(): string;
    /**
     * @stability stable
     */
    get smartProxyEnabled(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAzurermHealthcareServiceCorsConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get allowCredentials(): boolean;
    /**
     * @stability stable
     */
    get allowedHeaders(): string[];
    /**
     * @stability stable
     */
    get allowedMethods(): string[];
    /**
     * @stability stable
     */
    get allowedOrigins(): string[];
    /**
     * @stability stable
     */
    get maxAgeInSeconds(): number;
}
/**
 * @stability stable
 */
export interface DataAzurermHealthcareServiceTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/healthcare_service.html#read DataAzurermHealthcareService#read}.
     *
     * @stability stable
     */
    readonly read?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/d/healthcare_service.html azurerm_healthcare_service}.
 *
 * @stability stable
 */
export declare class DataAzurermHealthcareService extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/d/healthcare_service.html azurerm_healthcare_service} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAzurermHealthcareServiceConfig);
    /**
     * @stability stable
     */
    get accessPolicyObjectIds(): string[];
    /**
     * @stability stable
     */
    authenticationConfiguration(index: string): DataAzurermHealthcareServiceAuthenticationConfiguration;
    /**
     * @stability stable
     */
    corsConfiguration(index: string): DataAzurermHealthcareServiceCorsConfiguration;
    /**
     * @stability stable
     */
    get cosmosdbKeyVaultKeyVersionlessId(): string;
    /**
     * @stability stable
     */
    get cosmosdbThroughput(): number;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get kind(): string;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    /**
     * @stability stable
     */
    tags(key: string): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DataAzurermHealthcareServiceTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DataAzurermHealthcareServiceTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DataAzurermHealthcareServiceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
