import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAzurermStorageAccountSasConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#connection_string DataAzurermStorageAccountSas#connection_string}.
     *
     * @stability stable
     */
    readonly connectionString: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#expiry DataAzurermStorageAccountSas#expiry}.
     *
     * @stability stable
     */
    readonly expiry: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#https_only DataAzurermStorageAccountSas#https_only}.
     *
     * @stability stable
     */
    readonly httpsOnly?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#signed_version DataAzurermStorageAccountSas#signed_version}.
     *
     * @stability stable
     */
    readonly signedVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#start DataAzurermStorageAccountSas#start}.
     *
     * @stability stable
     */
    readonly start: string;
    /**
     * permissions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#permissions DataAzurermStorageAccountSas#permissions}
     *
     * @stability stable
     */
    readonly permissions: DataAzurermStorageAccountSasPermissions[];
    /**
     * resource_types block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#resource_types DataAzurermStorageAccountSas#resource_types}
     *
     * @stability stable
     */
    readonly resourceTypes: DataAzurermStorageAccountSasResourceTypes[];
    /**
     * services block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#services DataAzurermStorageAccountSas#services}
     *
     * @stability stable
     */
    readonly services: DataAzurermStorageAccountSasServices[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#timeouts DataAzurermStorageAccountSas#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DataAzurermStorageAccountSasTimeouts;
}
/**
 * @stability stable
 */
export interface DataAzurermStorageAccountSasPermissions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#add DataAzurermStorageAccountSas#add}.
     *
     * @stability stable
     */
    readonly add: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#create DataAzurermStorageAccountSas#create}.
     *
     * @stability stable
     */
    readonly create: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#delete DataAzurermStorageAccountSas#delete}.
     *
     * @stability stable
     */
    readonly delete: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#list DataAzurermStorageAccountSas#list}.
     *
     * @stability stable
     */
    readonly list: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#process DataAzurermStorageAccountSas#process}.
     *
     * @stability stable
     */
    readonly process: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#read DataAzurermStorageAccountSas#read}.
     *
     * @stability stable
     */
    readonly read: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#update DataAzurermStorageAccountSas#update}.
     *
     * @stability stable
     */
    readonly update: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#write DataAzurermStorageAccountSas#write}.
     *
     * @stability stable
     */
    readonly write: boolean;
}
/**
 * @stability stable
 */
export interface DataAzurermStorageAccountSasResourceTypes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#container DataAzurermStorageAccountSas#container}.
     *
     * @stability stable
     */
    readonly container: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#object DataAzurermStorageAccountSas#object}.
     *
     * @stability stable
     */
    readonly object: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#service DataAzurermStorageAccountSas#service}.
     *
     * @stability stable
     */
    readonly service: boolean;
}
/**
 * @stability stable
 */
export interface DataAzurermStorageAccountSasServices {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#blob DataAzurermStorageAccountSas#blob}.
     *
     * @stability stable
     */
    readonly blob: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#file DataAzurermStorageAccountSas#file}.
     *
     * @stability stable
     */
    readonly file: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#queue DataAzurermStorageAccountSas#queue}.
     *
     * @stability stable
     */
    readonly queue: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#table DataAzurermStorageAccountSas#table}.
     *
     * @stability stable
     */
    readonly table: boolean;
}
/**
 * @stability stable
 */
export interface DataAzurermStorageAccountSasTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html#read DataAzurermStorageAccountSas#read}.
     *
     * @stability stable
     */
    readonly read?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html azurerm_storage_account_sas}.
 *
 * @stability stable
 */
export declare class DataAzurermStorageAccountSas extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/d/storage_account_sas.html azurerm_storage_account_sas} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAzurermStorageAccountSasConfig);
    private _connectionString;
    /**
     * @stability stable
     */
    get connectionString(): string;
    /**
     * @stability stable
     */
    set connectionString(value: string);
    /**
     * @stability stable
     */
    get connectionStringInput(): string;
    private _expiry;
    /**
     * @stability stable
     */
    get expiry(): string;
    /**
     * @stability stable
     */
    set expiry(value: string);
    /**
     * @stability stable
     */
    get expiryInput(): string;
    private _httpsOnly?;
    /**
     * @stability stable
     */
    get httpsOnly(): boolean;
    /**
     * @stability stable
     */
    set httpsOnly(value: boolean);
    /**
     * @stability stable
     */
    resetHttpsOnly(): void;
    /**
     * @stability stable
     */
    get httpsOnlyInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get sas(): string;
    private _signedVersion?;
    /**
     * @stability stable
     */
    get signedVersion(): string;
    /**
     * @stability stable
     */
    set signedVersion(value: string);
    /**
     * @stability stable
     */
    resetSignedVersion(): void;
    /**
     * @stability stable
     */
    get signedVersionInput(): string | undefined;
    private _start;
    /**
     * @stability stable
     */
    get start(): string;
    /**
     * @stability stable
     */
    set start(value: string);
    /**
     * @stability stable
     */
    get startInput(): string;
    private _permissions;
    /**
     * @stability stable
     */
    get permissions(): DataAzurermStorageAccountSasPermissions[];
    /**
     * @stability stable
     */
    set permissions(value: DataAzurermStorageAccountSasPermissions[]);
    /**
     * @stability stable
     */
    get permissionsInput(): DataAzurermStorageAccountSasPermissions[];
    private _resourceTypes;
    /**
     * @stability stable
     */
    get resourceTypes(): DataAzurermStorageAccountSasResourceTypes[];
    /**
     * @stability stable
     */
    set resourceTypes(value: DataAzurermStorageAccountSasResourceTypes[]);
    /**
     * @stability stable
     */
    get resourceTypesInput(): DataAzurermStorageAccountSasResourceTypes[];
    private _services;
    /**
     * @stability stable
     */
    get services(): DataAzurermStorageAccountSasServices[];
    /**
     * @stability stable
     */
    set services(value: DataAzurermStorageAccountSasServices[]);
    /**
     * @stability stable
     */
    get servicesInput(): DataAzurermStorageAccountSasServices[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DataAzurermStorageAccountSasTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DataAzurermStorageAccountSasTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DataAzurermStorageAccountSasTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
