import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DevTestScheduleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#lab_name DevTestSchedule#lab_name}.
     *
     * @stability stable
     */
    readonly labName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#location DevTestSchedule#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#name DevTestSchedule#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#resource_group_name DevTestSchedule#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#status DevTestSchedule#status}.
     *
     * @stability stable
     */
    readonly status?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#tags DevTestSchedule#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#task_type DevTestSchedule#task_type}.
     *
     * @stability stable
     */
    readonly taskType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#time_zone_id DevTestSchedule#time_zone_id}.
     *
     * @stability stable
     */
    readonly timeZoneId: string;
    /**
     * daily_recurrence block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#daily_recurrence DevTestSchedule#daily_recurrence}
     *
     * @stability stable
     */
    readonly dailyRecurrence?: DevTestScheduleDailyRecurrence[];
    /**
     * hourly_recurrence block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#hourly_recurrence DevTestSchedule#hourly_recurrence}
     *
     * @stability stable
     */
    readonly hourlyRecurrence?: DevTestScheduleHourlyRecurrence[];
    /**
     * notification_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#notification_settings DevTestSchedule#notification_settings}
     *
     * @stability stable
     */
    readonly notificationSettings: DevTestScheduleNotificationSettings[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#timeouts DevTestSchedule#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DevTestScheduleTimeouts;
    /**
     * weekly_recurrence block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#weekly_recurrence DevTestSchedule#weekly_recurrence}
     *
     * @stability stable
     */
    readonly weeklyRecurrence?: DevTestScheduleWeeklyRecurrence[];
}
/**
 * @stability stable
 */
export interface DevTestScheduleDailyRecurrence {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#time DevTestSchedule#time}.
     *
     * @stability stable
     */
    readonly time: string;
}
/**
 * @stability stable
 */
export interface DevTestScheduleHourlyRecurrence {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#minute DevTestSchedule#minute}.
     *
     * @stability stable
     */
    readonly minute: number;
}
/**
 * @stability stable
 */
export interface DevTestScheduleNotificationSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#status DevTestSchedule#status}.
     *
     * @stability stable
     */
    readonly status?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#time_in_minutes DevTestSchedule#time_in_minutes}.
     *
     * @stability stable
     */
    readonly timeInMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#webhook_url DevTestSchedule#webhook_url}.
     *
     * @stability stable
     */
    readonly webhookUrl?: string;
}
/**
 * @stability stable
 */
export interface DevTestScheduleTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#create DevTestSchedule#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#delete DevTestSchedule#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#read DevTestSchedule#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#update DevTestSchedule#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export interface DevTestScheduleWeeklyRecurrence {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#time DevTestSchedule#time}.
     *
     * @stability stable
     */
    readonly time: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html#week_days DevTestSchedule#week_days}.
     *
     * @stability stable
     */
    readonly weekDays?: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html azurerm_dev_test_schedule}.
 *
 * @stability stable
 */
export declare class DevTestSchedule extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_schedule.html azurerm_dev_test_schedule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DevTestScheduleConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _labName;
    /**
     * @stability stable
     */
    get labName(): string;
    /**
     * @stability stable
     */
    set labName(value: string);
    /**
     * @stability stable
     */
    get labNameInput(): string;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _taskType;
    /**
     * @stability stable
     */
    get taskType(): string;
    /**
     * @stability stable
     */
    set taskType(value: string);
    /**
     * @stability stable
     */
    get taskTypeInput(): string;
    private _timeZoneId;
    /**
     * @stability stable
     */
    get timeZoneId(): string;
    /**
     * @stability stable
     */
    set timeZoneId(value: string);
    /**
     * @stability stable
     */
    get timeZoneIdInput(): string;
    private _dailyRecurrence?;
    /**
     * @stability stable
     */
    get dailyRecurrence(): DevTestScheduleDailyRecurrence[];
    /**
     * @stability stable
     */
    set dailyRecurrence(value: DevTestScheduleDailyRecurrence[]);
    /**
     * @stability stable
     */
    resetDailyRecurrence(): void;
    /**
     * @stability stable
     */
    get dailyRecurrenceInput(): DevTestScheduleDailyRecurrence[] | undefined;
    private _hourlyRecurrence?;
    /**
     * @stability stable
     */
    get hourlyRecurrence(): DevTestScheduleHourlyRecurrence[];
    /**
     * @stability stable
     */
    set hourlyRecurrence(value: DevTestScheduleHourlyRecurrence[]);
    /**
     * @stability stable
     */
    resetHourlyRecurrence(): void;
    /**
     * @stability stable
     */
    get hourlyRecurrenceInput(): DevTestScheduleHourlyRecurrence[] | undefined;
    private _notificationSettings;
    /**
     * @stability stable
     */
    get notificationSettings(): DevTestScheduleNotificationSettings[];
    /**
     * @stability stable
     */
    set notificationSettings(value: DevTestScheduleNotificationSettings[]);
    /**
     * @stability stable
     */
    get notificationSettingsInput(): DevTestScheduleNotificationSettings[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DevTestScheduleTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DevTestScheduleTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DevTestScheduleTimeouts | undefined;
    private _weeklyRecurrence?;
    /**
     * @stability stable
     */
    get weeklyRecurrence(): DevTestScheduleWeeklyRecurrence[];
    /**
     * @stability stable
     */
    set weeklyRecurrence(value: DevTestScheduleWeeklyRecurrence[]);
    /**
     * @stability stable
     */
    resetWeeklyRecurrence(): void;
    /**
     * @stability stable
     */
    get weeklyRecurrenceInput(): DevTestScheduleWeeklyRecurrence[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
