import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DevTestWindowsVirtualMachineConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#allow_claim DevTestWindowsVirtualMachine#allow_claim}.
     *
     * @stability stable
     */
    readonly allowClaim?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#disallow_public_ip_address DevTestWindowsVirtualMachine#disallow_public_ip_address}.
     *
     * @stability stable
     */
    readonly disallowPublicIpAddress?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#lab_name DevTestWindowsVirtualMachine#lab_name}.
     *
     * @stability stable
     */
    readonly labName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#lab_subnet_name DevTestWindowsVirtualMachine#lab_subnet_name}.
     *
     * @stability stable
     */
    readonly labSubnetName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#lab_virtual_network_id DevTestWindowsVirtualMachine#lab_virtual_network_id}.
     *
     * @stability stable
     */
    readonly labVirtualNetworkId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#location DevTestWindowsVirtualMachine#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#name DevTestWindowsVirtualMachine#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#notes DevTestWindowsVirtualMachine#notes}.
     *
     * @stability stable
     */
    readonly notes?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#password DevTestWindowsVirtualMachine#password}.
     *
     * @stability stable
     */
    readonly password: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#resource_group_name DevTestWindowsVirtualMachine#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#size DevTestWindowsVirtualMachine#size}.
     *
     * @stability stable
     */
    readonly size: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#storage_type DevTestWindowsVirtualMachine#storage_type}.
     *
     * @stability stable
     */
    readonly storageType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#tags DevTestWindowsVirtualMachine#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#username DevTestWindowsVirtualMachine#username}.
     *
     * @stability stable
     */
    readonly username: string;
    /**
     * gallery_image_reference block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#gallery_image_reference DevTestWindowsVirtualMachine#gallery_image_reference}
     *
     * @stability stable
     */
    readonly galleryImageReference: DevTestWindowsVirtualMachineGalleryImageReference[];
    /**
     * inbound_nat_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#inbound_nat_rule DevTestWindowsVirtualMachine#inbound_nat_rule}
     *
     * @stability stable
     */
    readonly inboundNatRule?: DevTestWindowsVirtualMachineInboundNatRule[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#timeouts DevTestWindowsVirtualMachine#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DevTestWindowsVirtualMachineTimeouts;
}
/**
 * @stability stable
 */
export interface DevTestWindowsVirtualMachineGalleryImageReference {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#offer DevTestWindowsVirtualMachine#offer}.
     *
     * @stability stable
     */
    readonly offer: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#publisher DevTestWindowsVirtualMachine#publisher}.
     *
     * @stability stable
     */
    readonly publisher: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#sku DevTestWindowsVirtualMachine#sku}.
     *
     * @stability stable
     */
    readonly sku: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#version DevTestWindowsVirtualMachine#version}.
     *
     * @stability stable
     */
    readonly version: string;
}
/**
 * @stability stable
 */
export interface DevTestWindowsVirtualMachineInboundNatRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#backend_port DevTestWindowsVirtualMachine#backend_port}.
     *
     * @stability stable
     */
    readonly backendPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#protocol DevTestWindowsVirtualMachine#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
}
/**
 * @stability stable
 */
export interface DevTestWindowsVirtualMachineTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#create DevTestWindowsVirtualMachine#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#delete DevTestWindowsVirtualMachine#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#read DevTestWindowsVirtualMachine#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html#update DevTestWindowsVirtualMachine#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html azurerm_dev_test_windows_virtual_machine}.
 *
 * @stability stable
 */
export declare class DevTestWindowsVirtualMachine extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/dev_test_windows_virtual_machine.html azurerm_dev_test_windows_virtual_machine} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DevTestWindowsVirtualMachineConfig);
    private _allowClaim?;
    /**
     * @stability stable
     */
    get allowClaim(): boolean;
    /**
     * @stability stable
     */
    set allowClaim(value: boolean);
    /**
     * @stability stable
     */
    resetAllowClaim(): void;
    /**
     * @stability stable
     */
    get allowClaimInput(): boolean | undefined;
    private _disallowPublicIpAddress?;
    /**
     * @stability stable
     */
    get disallowPublicIpAddress(): boolean;
    /**
     * @stability stable
     */
    set disallowPublicIpAddress(value: boolean);
    /**
     * @stability stable
     */
    resetDisallowPublicIpAddress(): void;
    /**
     * @stability stable
     */
    get disallowPublicIpAddressInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get fqdn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _labName;
    /**
     * @stability stable
     */
    get labName(): string;
    /**
     * @stability stable
     */
    set labName(value: string);
    /**
     * @stability stable
     */
    get labNameInput(): string;
    private _labSubnetName;
    /**
     * @stability stable
     */
    get labSubnetName(): string;
    /**
     * @stability stable
     */
    set labSubnetName(value: string);
    /**
     * @stability stable
     */
    get labSubnetNameInput(): string;
    private _labVirtualNetworkId;
    /**
     * @stability stable
     */
    get labVirtualNetworkId(): string;
    /**
     * @stability stable
     */
    set labVirtualNetworkId(value: string);
    /**
     * @stability stable
     */
    get labVirtualNetworkIdInput(): string;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _notes?;
    /**
     * @stability stable
     */
    get notes(): string;
    /**
     * @stability stable
     */
    set notes(value: string);
    /**
     * @stability stable
     */
    resetNotes(): void;
    /**
     * @stability stable
     */
    get notesInput(): string | undefined;
    private _password;
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    set password(value: string);
    /**
     * @stability stable
     */
    get passwordInput(): string;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _size;
    /**
     * @stability stable
     */
    get size(): string;
    /**
     * @stability stable
     */
    set size(value: string);
    /**
     * @stability stable
     */
    get sizeInput(): string;
    private _storageType;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    set storageType(value: string);
    /**
     * @stability stable
     */
    get storageTypeInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get uniqueIdentifier(): string;
    private _username;
    /**
     * @stability stable
     */
    get username(): string;
    /**
     * @stability stable
     */
    set username(value: string);
    /**
     * @stability stable
     */
    get usernameInput(): string;
    private _galleryImageReference;
    /**
     * @stability stable
     */
    get galleryImageReference(): DevTestWindowsVirtualMachineGalleryImageReference[];
    /**
     * @stability stable
     */
    set galleryImageReference(value: DevTestWindowsVirtualMachineGalleryImageReference[]);
    /**
     * @stability stable
     */
    get galleryImageReferenceInput(): DevTestWindowsVirtualMachineGalleryImageReference[];
    private _inboundNatRule?;
    /**
     * @stability stable
     */
    get inboundNatRule(): DevTestWindowsVirtualMachineInboundNatRule[];
    /**
     * @stability stable
     */
    set inboundNatRule(value: DevTestWindowsVirtualMachineInboundNatRule[]);
    /**
     * @stability stable
     */
    resetInboundNatRule(): void;
    /**
     * @stability stable
     */
    get inboundNatRuleInput(): DevTestWindowsVirtualMachineInboundNatRule[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DevTestWindowsVirtualMachineTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DevTestWindowsVirtualMachineTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DevTestWindowsVirtualMachineTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
