import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#event_delivery_schema EventgridEventSubscription#event_delivery_schema}.
     *
     * @stability stable
     */
    readonly eventDeliverySchema?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#eventhub_endpoint_id EventgridEventSubscription#eventhub_endpoint_id}.
     *
     * @stability stable
     */
    readonly eventhubEndpointId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#expiration_time_utc EventgridEventSubscription#expiration_time_utc}.
     *
     * @stability stable
     */
    readonly expirationTimeUtc?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#hybrid_connection_endpoint_id EventgridEventSubscription#hybrid_connection_endpoint_id}.
     *
     * @stability stable
     */
    readonly hybridConnectionEndpointId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#included_event_types EventgridEventSubscription#included_event_types}.
     *
     * @stability stable
     */
    readonly includedEventTypes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#labels EventgridEventSubscription#labels}.
     *
     * @stability stable
     */
    readonly labels?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#name EventgridEventSubscription#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#scope EventgridEventSubscription#scope}.
     *
     * @stability stable
     */
    readonly scope: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#service_bus_queue_endpoint_id EventgridEventSubscription#service_bus_queue_endpoint_id}.
     *
     * @stability stable
     */
    readonly serviceBusQueueEndpointId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#service_bus_topic_endpoint_id EventgridEventSubscription#service_bus_topic_endpoint_id}.
     *
     * @stability stable
     */
    readonly serviceBusTopicEndpointId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#topic_name EventgridEventSubscription#topic_name}.
     *
     * @stability stable
     */
    readonly topicName?: string;
    /**
     * advanced_filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#advanced_filter EventgridEventSubscription#advanced_filter}
     *
     * @stability stable
     */
    readonly advancedFilter?: EventgridEventSubscriptionAdvancedFilter[];
    /**
     * azure_function_endpoint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#azure_function_endpoint EventgridEventSubscription#azure_function_endpoint}
     *
     * @stability stable
     */
    readonly azureFunctionEndpoint?: EventgridEventSubscriptionAzureFunctionEndpoint[];
    /**
     * eventhub_endpoint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#eventhub_endpoint EventgridEventSubscription#eventhub_endpoint}
     *
     * @stability stable
     */
    readonly eventhubEndpoint?: EventgridEventSubscriptionEventhubEndpoint[];
    /**
     * hybrid_connection_endpoint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#hybrid_connection_endpoint EventgridEventSubscription#hybrid_connection_endpoint}
     *
     * @stability stable
     */
    readonly hybridConnectionEndpoint?: EventgridEventSubscriptionHybridConnectionEndpoint[];
    /**
     * retry_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#retry_policy EventgridEventSubscription#retry_policy}
     *
     * @stability stable
     */
    readonly retryPolicy?: EventgridEventSubscriptionRetryPolicy[];
    /**
     * storage_blob_dead_letter_destination block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#storage_blob_dead_letter_destination EventgridEventSubscription#storage_blob_dead_letter_destination}
     *
     * @stability stable
     */
    readonly storageBlobDeadLetterDestination?: EventgridEventSubscriptionStorageBlobDeadLetterDestination[];
    /**
     * storage_queue_endpoint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#storage_queue_endpoint EventgridEventSubscription#storage_queue_endpoint}
     *
     * @stability stable
     */
    readonly storageQueueEndpoint?: EventgridEventSubscriptionStorageQueueEndpoint[];
    /**
     * subject_filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#subject_filter EventgridEventSubscription#subject_filter}
     *
     * @stability stable
     */
    readonly subjectFilter?: EventgridEventSubscriptionSubjectFilter[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#timeouts EventgridEventSubscription#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: EventgridEventSubscriptionTimeouts;
    /**
     * webhook_endpoint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#webhook_endpoint EventgridEventSubscription#webhook_endpoint}
     *
     * @stability stable
     */
    readonly webhookEndpoint?: EventgridEventSubscriptionWebhookEndpoint[];
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAdvancedFilterBoolEquals {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#key EventgridEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#value EventgridEventSubscription#value}.
     *
     * @stability stable
     */
    readonly value: boolean;
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAdvancedFilterNumberGreaterThan {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#key EventgridEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#value EventgridEventSubscription#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAdvancedFilterNumberGreaterThanOrEquals {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#key EventgridEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#value EventgridEventSubscription#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAdvancedFilterNumberIn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#key EventgridEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#values EventgridEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: number[];
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAdvancedFilterNumberLessThan {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#key EventgridEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#value EventgridEventSubscription#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAdvancedFilterNumberLessThanOrEquals {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#key EventgridEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#value EventgridEventSubscription#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAdvancedFilterNumberNotIn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#key EventgridEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#values EventgridEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: number[];
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAdvancedFilterStringBeginsWith {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#key EventgridEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#values EventgridEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAdvancedFilterStringContains {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#key EventgridEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#values EventgridEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAdvancedFilterStringEndsWith {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#key EventgridEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#values EventgridEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAdvancedFilterStringIn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#key EventgridEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#values EventgridEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAdvancedFilterStringNotIn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#key EventgridEventSubscription#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#values EventgridEventSubscription#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAdvancedFilter {
    /**
     * bool_equals block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#bool_equals EventgridEventSubscription#bool_equals}
     *
     * @stability stable
     */
    readonly boolEquals?: EventgridEventSubscriptionAdvancedFilterBoolEquals[];
    /**
     * number_greater_than block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#number_greater_than EventgridEventSubscription#number_greater_than}
     *
     * @stability stable
     */
    readonly numberGreaterThan?: EventgridEventSubscriptionAdvancedFilterNumberGreaterThan[];
    /**
     * number_greater_than_or_equals block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#number_greater_than_or_equals EventgridEventSubscription#number_greater_than_or_equals}
     *
     * @stability stable
     */
    readonly numberGreaterThanOrEquals?: EventgridEventSubscriptionAdvancedFilterNumberGreaterThanOrEquals[];
    /**
     * number_in block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#number_in EventgridEventSubscription#number_in}
     *
     * @stability stable
     */
    readonly numberIn?: EventgridEventSubscriptionAdvancedFilterNumberIn[];
    /**
     * number_less_than block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#number_less_than EventgridEventSubscription#number_less_than}
     *
     * @stability stable
     */
    readonly numberLessThan?: EventgridEventSubscriptionAdvancedFilterNumberLessThan[];
    /**
     * number_less_than_or_equals block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#number_less_than_or_equals EventgridEventSubscription#number_less_than_or_equals}
     *
     * @stability stable
     */
    readonly numberLessThanOrEquals?: EventgridEventSubscriptionAdvancedFilterNumberLessThanOrEquals[];
    /**
     * number_not_in block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#number_not_in EventgridEventSubscription#number_not_in}
     *
     * @stability stable
     */
    readonly numberNotIn?: EventgridEventSubscriptionAdvancedFilterNumberNotIn[];
    /**
     * string_begins_with block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#string_begins_with EventgridEventSubscription#string_begins_with}
     *
     * @stability stable
     */
    readonly stringBeginsWith?: EventgridEventSubscriptionAdvancedFilterStringBeginsWith[];
    /**
     * string_contains block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#string_contains EventgridEventSubscription#string_contains}
     *
     * @stability stable
     */
    readonly stringContains?: EventgridEventSubscriptionAdvancedFilterStringContains[];
    /**
     * string_ends_with block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#string_ends_with EventgridEventSubscription#string_ends_with}
     *
     * @stability stable
     */
    readonly stringEndsWith?: EventgridEventSubscriptionAdvancedFilterStringEndsWith[];
    /**
     * string_in block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#string_in EventgridEventSubscription#string_in}
     *
     * @stability stable
     */
    readonly stringIn?: EventgridEventSubscriptionAdvancedFilterStringIn[];
    /**
     * string_not_in block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#string_not_in EventgridEventSubscription#string_not_in}
     *
     * @stability stable
     */
    readonly stringNotIn?: EventgridEventSubscriptionAdvancedFilterStringNotIn[];
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionAzureFunctionEndpoint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#function_id EventgridEventSubscription#function_id}.
     *
     * @stability stable
     */
    readonly functionId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#max_events_per_batch EventgridEventSubscription#max_events_per_batch}.
     *
     * @stability stable
     */
    readonly maxEventsPerBatch?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#preferred_batch_size_in_kilobytes EventgridEventSubscription#preferred_batch_size_in_kilobytes}.
     *
     * @stability stable
     */
    readonly preferredBatchSizeInKilobytes?: number;
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionEventhubEndpoint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#eventhub_id EventgridEventSubscription#eventhub_id}.
     *
     * @stability stable
     */
    readonly eventhubId?: string;
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionHybridConnectionEndpoint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#hybrid_connection_id EventgridEventSubscription#hybrid_connection_id}.
     *
     * @stability stable
     */
    readonly hybridConnectionId?: string;
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionRetryPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#event_time_to_live EventgridEventSubscription#event_time_to_live}.
     *
     * @stability stable
     */
    readonly eventTimeToLive: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#max_delivery_attempts EventgridEventSubscription#max_delivery_attempts}.
     *
     * @stability stable
     */
    readonly maxDeliveryAttempts: number;
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionStorageBlobDeadLetterDestination {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#storage_account_id EventgridEventSubscription#storage_account_id}.
     *
     * @stability stable
     */
    readonly storageAccountId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#storage_blob_container_name EventgridEventSubscription#storage_blob_container_name}.
     *
     * @stability stable
     */
    readonly storageBlobContainerName: string;
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionStorageQueueEndpoint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#queue_name EventgridEventSubscription#queue_name}.
     *
     * @stability stable
     */
    readonly queueName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#storage_account_id EventgridEventSubscription#storage_account_id}.
     *
     * @stability stable
     */
    readonly storageAccountId: string;
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionSubjectFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#case_sensitive EventgridEventSubscription#case_sensitive}.
     *
     * @stability stable
     */
    readonly caseSensitive?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#subject_begins_with EventgridEventSubscription#subject_begins_with}.
     *
     * @stability stable
     */
    readonly subjectBeginsWith?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#subject_ends_with EventgridEventSubscription#subject_ends_with}.
     *
     * @stability stable
     */
    readonly subjectEndsWith?: string;
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#create EventgridEventSubscription#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#delete EventgridEventSubscription#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#read EventgridEventSubscription#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#update EventgridEventSubscription#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export interface EventgridEventSubscriptionWebhookEndpoint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#active_directory_app_id_or_uri EventgridEventSubscription#active_directory_app_id_or_uri}.
     *
     * @stability stable
     */
    readonly activeDirectoryAppIdOrUri?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#active_directory_tenant_id EventgridEventSubscription#active_directory_tenant_id}.
     *
     * @stability stable
     */
    readonly activeDirectoryTenantId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#max_events_per_batch EventgridEventSubscription#max_events_per_batch}.
     *
     * @stability stable
     */
    readonly maxEventsPerBatch?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#preferred_batch_size_in_kilobytes EventgridEventSubscription#preferred_batch_size_in_kilobytes}.
     *
     * @stability stable
     */
    readonly preferredBatchSizeInKilobytes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html#url EventgridEventSubscription#url}.
     *
     * @stability stable
     */
    readonly url: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html azurerm_eventgrid_event_subscription}.
 *
 * @stability stable
 */
export declare class EventgridEventSubscription extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/eventgrid_event_subscription.html azurerm_eventgrid_event_subscription} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EventgridEventSubscriptionConfig);
    private _eventDeliverySchema?;
    /**
     * @stability stable
     */
    get eventDeliverySchema(): string;
    /**
     * @stability stable
     */
    set eventDeliverySchema(value: string);
    /**
     * @stability stable
     */
    resetEventDeliverySchema(): void;
    /**
     * @stability stable
     */
    get eventDeliverySchemaInput(): string | undefined;
    private _eventhubEndpointId?;
    /**
     * @stability stable
     */
    get eventhubEndpointId(): string;
    /**
     * @stability stable
     */
    set eventhubEndpointId(value: string);
    /**
     * @stability stable
     */
    resetEventhubEndpointId(): void;
    /**
     * @stability stable
     */
    get eventhubEndpointIdInput(): string | undefined;
    private _expirationTimeUtc?;
    /**
     * @stability stable
     */
    get expirationTimeUtc(): string;
    /**
     * @stability stable
     */
    set expirationTimeUtc(value: string);
    /**
     * @stability stable
     */
    resetExpirationTimeUtc(): void;
    /**
     * @stability stable
     */
    get expirationTimeUtcInput(): string | undefined;
    private _hybridConnectionEndpointId?;
    /**
     * @stability stable
     */
    get hybridConnectionEndpointId(): string;
    /**
     * @stability stable
     */
    set hybridConnectionEndpointId(value: string);
    /**
     * @stability stable
     */
    resetHybridConnectionEndpointId(): void;
    /**
     * @stability stable
     */
    get hybridConnectionEndpointIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _includedEventTypes?;
    /**
     * @stability stable
     */
    get includedEventTypes(): string[];
    /**
     * @stability stable
     */
    set includedEventTypes(value: string[]);
    /**
     * @stability stable
     */
    resetIncludedEventTypes(): void;
    /**
     * @stability stable
     */
    get includedEventTypesInput(): string[] | undefined;
    private _labels?;
    /**
     * @stability stable
     */
    get labels(): string[];
    /**
     * @stability stable
     */
    set labels(value: string[]);
    /**
     * @stability stable
     */
    resetLabels(): void;
    /**
     * @stability stable
     */
    get labelsInput(): string[] | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _scope;
    /**
     * @stability stable
     */
    get scope(): string;
    /**
     * @stability stable
     */
    set scope(value: string);
    /**
     * @stability stable
     */
    get scopeInput(): string;
    private _serviceBusQueueEndpointId?;
    /**
     * @stability stable
     */
    get serviceBusQueueEndpointId(): string;
    /**
     * @stability stable
     */
    set serviceBusQueueEndpointId(value: string);
    /**
     * @stability stable
     */
    resetServiceBusQueueEndpointId(): void;
    /**
     * @stability stable
     */
    get serviceBusQueueEndpointIdInput(): string | undefined;
    private _serviceBusTopicEndpointId?;
    /**
     * @stability stable
     */
    get serviceBusTopicEndpointId(): string;
    /**
     * @stability stable
     */
    set serviceBusTopicEndpointId(value: string);
    /**
     * @stability stable
     */
    resetServiceBusTopicEndpointId(): void;
    /**
     * @stability stable
     */
    get serviceBusTopicEndpointIdInput(): string | undefined;
    private _topicName?;
    /**
     * @stability stable
     */
    get topicName(): string;
    /**
     * @stability stable
     */
    set topicName(value: string);
    /**
     * @stability stable
     */
    resetTopicName(): void;
    /**
     * @stability stable
     */
    get topicNameInput(): string | undefined;
    private _advancedFilter?;
    /**
     * @stability stable
     */
    get advancedFilter(): EventgridEventSubscriptionAdvancedFilter[];
    /**
     * @stability stable
     */
    set advancedFilter(value: EventgridEventSubscriptionAdvancedFilter[]);
    /**
     * @stability stable
     */
    resetAdvancedFilter(): void;
    /**
     * @stability stable
     */
    get advancedFilterInput(): EventgridEventSubscriptionAdvancedFilter[] | undefined;
    private _azureFunctionEndpoint?;
    /**
     * @stability stable
     */
    get azureFunctionEndpoint(): EventgridEventSubscriptionAzureFunctionEndpoint[];
    /**
     * @stability stable
     */
    set azureFunctionEndpoint(value: EventgridEventSubscriptionAzureFunctionEndpoint[]);
    /**
     * @stability stable
     */
    resetAzureFunctionEndpoint(): void;
    /**
     * @stability stable
     */
    get azureFunctionEndpointInput(): EventgridEventSubscriptionAzureFunctionEndpoint[] | undefined;
    private _eventhubEndpoint?;
    /**
     * @stability stable
     */
    get eventhubEndpoint(): EventgridEventSubscriptionEventhubEndpoint[];
    /**
     * @stability stable
     */
    set eventhubEndpoint(value: EventgridEventSubscriptionEventhubEndpoint[]);
    /**
     * @stability stable
     */
    resetEventhubEndpoint(): void;
    /**
     * @stability stable
     */
    get eventhubEndpointInput(): EventgridEventSubscriptionEventhubEndpoint[] | undefined;
    private _hybridConnectionEndpoint?;
    /**
     * @stability stable
     */
    get hybridConnectionEndpoint(): EventgridEventSubscriptionHybridConnectionEndpoint[];
    /**
     * @stability stable
     */
    set hybridConnectionEndpoint(value: EventgridEventSubscriptionHybridConnectionEndpoint[]);
    /**
     * @stability stable
     */
    resetHybridConnectionEndpoint(): void;
    /**
     * @stability stable
     */
    get hybridConnectionEndpointInput(): EventgridEventSubscriptionHybridConnectionEndpoint[] | undefined;
    private _retryPolicy?;
    /**
     * @stability stable
     */
    get retryPolicy(): EventgridEventSubscriptionRetryPolicy[];
    /**
     * @stability stable
     */
    set retryPolicy(value: EventgridEventSubscriptionRetryPolicy[]);
    /**
     * @stability stable
     */
    resetRetryPolicy(): void;
    /**
     * @stability stable
     */
    get retryPolicyInput(): EventgridEventSubscriptionRetryPolicy[] | undefined;
    private _storageBlobDeadLetterDestination?;
    /**
     * @stability stable
     */
    get storageBlobDeadLetterDestination(): EventgridEventSubscriptionStorageBlobDeadLetterDestination[];
    /**
     * @stability stable
     */
    set storageBlobDeadLetterDestination(value: EventgridEventSubscriptionStorageBlobDeadLetterDestination[]);
    /**
     * @stability stable
     */
    resetStorageBlobDeadLetterDestination(): void;
    /**
     * @stability stable
     */
    get storageBlobDeadLetterDestinationInput(): EventgridEventSubscriptionStorageBlobDeadLetterDestination[] | undefined;
    private _storageQueueEndpoint?;
    /**
     * @stability stable
     */
    get storageQueueEndpoint(): EventgridEventSubscriptionStorageQueueEndpoint[];
    /**
     * @stability stable
     */
    set storageQueueEndpoint(value: EventgridEventSubscriptionStorageQueueEndpoint[]);
    /**
     * @stability stable
     */
    resetStorageQueueEndpoint(): void;
    /**
     * @stability stable
     */
    get storageQueueEndpointInput(): EventgridEventSubscriptionStorageQueueEndpoint[] | undefined;
    private _subjectFilter?;
    /**
     * @stability stable
     */
    get subjectFilter(): EventgridEventSubscriptionSubjectFilter[];
    /**
     * @stability stable
     */
    set subjectFilter(value: EventgridEventSubscriptionSubjectFilter[]);
    /**
     * @stability stable
     */
    resetSubjectFilter(): void;
    /**
     * @stability stable
     */
    get subjectFilterInput(): EventgridEventSubscriptionSubjectFilter[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): EventgridEventSubscriptionTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: EventgridEventSubscriptionTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): EventgridEventSubscriptionTimeouts | undefined;
    private _webhookEndpoint?;
    /**
     * @stability stable
     */
    get webhookEndpoint(): EventgridEventSubscriptionWebhookEndpoint[];
    /**
     * @stability stable
     */
    set webhookEndpoint(value: EventgridEventSubscriptionWebhookEndpoint[]);
    /**
     * @stability stable
     */
    resetWebhookEndpoint(): void;
    /**
     * @stability stable
     */
    get webhookEndpointInput(): EventgridEventSubscriptionWebhookEndpoint[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
