import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface HpcCacheConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#cache_size_in_gb HpcCache#cache_size_in_gb}.
     *
     * @stability stable
     */
    readonly cacheSizeInGb: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#location HpcCache#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#mtu HpcCache#mtu}.
     *
     * @stability stable
     */
    readonly mtu?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#name HpcCache#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#ntp_server HpcCache#ntp_server}.
     *
     * @stability stable
     */
    readonly ntpServer?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#resource_group_name HpcCache#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#root_squash_enabled HpcCache#root_squash_enabled}.
     *
     * @stability stable
     */
    readonly rootSquashEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#sku_name HpcCache#sku_name}.
     *
     * @stability stable
     */
    readonly skuName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#subnet_id HpcCache#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#tags HpcCache#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * default_access_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#default_access_policy HpcCache#default_access_policy}
     *
     * @stability stable
     */
    readonly defaultAccessPolicy?: HpcCacheDefaultAccessPolicy[];
    /**
     * directory_active_directory block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#directory_active_directory HpcCache#directory_active_directory}
     *
     * @stability stable
     */
    readonly directoryActiveDirectory?: HpcCacheDirectoryActiveDirectory[];
    /**
     * directory_flat_file block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#directory_flat_file HpcCache#directory_flat_file}
     *
     * @stability stable
     */
    readonly directoryFlatFile?: HpcCacheDirectoryFlatFile[];
    /**
     * directory_ldap block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#directory_ldap HpcCache#directory_ldap}
     *
     * @stability stable
     */
    readonly directoryLdap?: HpcCacheDirectoryLdap[];
    /**
     * dns block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#dns HpcCache#dns}
     *
     * @stability stable
     */
    readonly dns?: HpcCacheDns[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#timeouts HpcCache#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: HpcCacheTimeouts;
}
/**
 * @stability stable
 */
export interface HpcCacheDefaultAccessPolicyAccessRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#access HpcCache#access}.
     *
     * @stability stable
     */
    readonly access: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#anonymous_gid HpcCache#anonymous_gid}.
     *
     * @stability stable
     */
    readonly anonymousGid?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#anonymous_uid HpcCache#anonymous_uid}.
     *
     * @stability stable
     */
    readonly anonymousUid?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#filter HpcCache#filter}.
     *
     * @stability stable
     */
    readonly filter?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#root_squash_enabled HpcCache#root_squash_enabled}.
     *
     * @stability stable
     */
    readonly rootSquashEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#scope HpcCache#scope}.
     *
     * @stability stable
     */
    readonly scope: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#submount_access_enabled HpcCache#submount_access_enabled}.
     *
     * @stability stable
     */
    readonly submountAccessEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#suid_enabled HpcCache#suid_enabled}.
     *
     * @stability stable
     */
    readonly suidEnabled?: boolean;
}
/**
 * @stability stable
 */
export interface HpcCacheDefaultAccessPolicy {
    /**
     * access_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#access_rule HpcCache#access_rule}
     *
     * @stability stable
     */
    readonly accessRule: HpcCacheDefaultAccessPolicyAccessRule[];
}
/**
 * @stability stable
 */
export interface HpcCacheDirectoryActiveDirectory {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#cache_netbios_name HpcCache#cache_netbios_name}.
     *
     * @stability stable
     */
    readonly cacheNetbiosName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#dns_primary_ip HpcCache#dns_primary_ip}.
     *
     * @stability stable
     */
    readonly dnsPrimaryIp: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#dns_secondary_ip HpcCache#dns_secondary_ip}.
     *
     * @stability stable
     */
    readonly dnsSecondaryIp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#domain_name HpcCache#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#domain_netbios_name HpcCache#domain_netbios_name}.
     *
     * @stability stable
     */
    readonly domainNetbiosName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#password HpcCache#password}.
     *
     * @stability stable
     */
    readonly password: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#username HpcCache#username}.
     *
     * @stability stable
     */
    readonly username: string;
}
/**
 * @stability stable
 */
export interface HpcCacheDirectoryFlatFile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#group_file_uri HpcCache#group_file_uri}.
     *
     * @stability stable
     */
    readonly groupFileUri: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#password_file_uri HpcCache#password_file_uri}.
     *
     * @stability stable
     */
    readonly passwordFileUri: string;
}
/**
 * @stability stable
 */
export interface HpcCacheDirectoryLdapBind {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#dn HpcCache#dn}.
     *
     * @stability stable
     */
    readonly dn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#password HpcCache#password}.
     *
     * @stability stable
     */
    readonly password: string;
}
/**
 * @stability stable
 */
export interface HpcCacheDirectoryLdap {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#base_dn HpcCache#base_dn}.
     *
     * @stability stable
     */
    readonly baseDn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#certificate_validation_uri HpcCache#certificate_validation_uri}.
     *
     * @stability stable
     */
    readonly certificateValidationUri?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#download_certificate_automatically HpcCache#download_certificate_automatically}.
     *
     * @stability stable
     */
    readonly downloadCertificateAutomatically?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#encrypted HpcCache#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#server HpcCache#server}.
     *
     * @stability stable
     */
    readonly server: string;
    /**
     * bind block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#bind HpcCache#bind}
     *
     * @stability stable
     */
    readonly bind?: HpcCacheDirectoryLdapBind[];
}
/**
 * @stability stable
 */
export interface HpcCacheDns {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#search_domain HpcCache#search_domain}.
     *
     * @stability stable
     */
    readonly searchDomain?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#servers HpcCache#servers}.
     *
     * @stability stable
     */
    readonly servers: string[];
}
/**
 * @stability stable
 */
export interface HpcCacheTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#create HpcCache#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#delete HpcCache#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#read HpcCache#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html#update HpcCache#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html azurerm_hpc_cache}.
 *
 * @stability stable
 */
export declare class HpcCache extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/hpc_cache.html azurerm_hpc_cache} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: HpcCacheConfig);
    private _cacheSizeInGb;
    /**
     * @stability stable
     */
    get cacheSizeInGb(): number;
    /**
     * @stability stable
     */
    set cacheSizeInGb(value: number);
    /**
     * @stability stable
     */
    get cacheSizeInGbInput(): number;
    /**
     * @stability stable
     */
    get id(): string;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    /**
     * @stability stable
     */
    get mountAddresses(): string[];
    private _mtu?;
    /**
     * @stability stable
     */
    get mtu(): number;
    /**
     * @stability stable
     */
    set mtu(value: number);
    /**
     * @stability stable
     */
    resetMtu(): void;
    /**
     * @stability stable
     */
    get mtuInput(): number | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _ntpServer?;
    /**
     * @stability stable
     */
    get ntpServer(): string;
    /**
     * @stability stable
     */
    set ntpServer(value: string);
    /**
     * @stability stable
     */
    resetNtpServer(): void;
    /**
     * @stability stable
     */
    get ntpServerInput(): string | undefined;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _rootSquashEnabled?;
    /**
     * @stability stable
     */
    get rootSquashEnabled(): boolean;
    /**
     * @stability stable
     */
    set rootSquashEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetRootSquashEnabled(): void;
    /**
     * @stability stable
     */
    get rootSquashEnabledInput(): boolean | undefined;
    private _skuName;
    /**
     * @stability stable
     */
    get skuName(): string;
    /**
     * @stability stable
     */
    set skuName(value: string);
    /**
     * @stability stable
     */
    get skuNameInput(): string;
    private _subnetId;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    get subnetIdInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _defaultAccessPolicy?;
    /**
     * @stability stable
     */
    get defaultAccessPolicy(): HpcCacheDefaultAccessPolicy[];
    /**
     * @stability stable
     */
    set defaultAccessPolicy(value: HpcCacheDefaultAccessPolicy[]);
    /**
     * @stability stable
     */
    resetDefaultAccessPolicy(): void;
    /**
     * @stability stable
     */
    get defaultAccessPolicyInput(): HpcCacheDefaultAccessPolicy[] | undefined;
    private _directoryActiveDirectory?;
    /**
     * @stability stable
     */
    get directoryActiveDirectory(): HpcCacheDirectoryActiveDirectory[];
    /**
     * @stability stable
     */
    set directoryActiveDirectory(value: HpcCacheDirectoryActiveDirectory[]);
    /**
     * @stability stable
     */
    resetDirectoryActiveDirectory(): void;
    /**
     * @stability stable
     */
    get directoryActiveDirectoryInput(): HpcCacheDirectoryActiveDirectory[] | undefined;
    private _directoryFlatFile?;
    /**
     * @stability stable
     */
    get directoryFlatFile(): HpcCacheDirectoryFlatFile[];
    /**
     * @stability stable
     */
    set directoryFlatFile(value: HpcCacheDirectoryFlatFile[]);
    /**
     * @stability stable
     */
    resetDirectoryFlatFile(): void;
    /**
     * @stability stable
     */
    get directoryFlatFileInput(): HpcCacheDirectoryFlatFile[] | undefined;
    private _directoryLdap?;
    /**
     * @stability stable
     */
    get directoryLdap(): HpcCacheDirectoryLdap[];
    /**
     * @stability stable
     */
    set directoryLdap(value: HpcCacheDirectoryLdap[]);
    /**
     * @stability stable
     */
    resetDirectoryLdap(): void;
    /**
     * @stability stable
     */
    get directoryLdapInput(): HpcCacheDirectoryLdap[] | undefined;
    private _dns?;
    /**
     * @stability stable
     */
    get dns(): HpcCacheDns[];
    /**
     * @stability stable
     */
    set dns(value: HpcCacheDns[]);
    /**
     * @stability stable
     */
    resetDns(): void;
    /**
     * @stability stable
     */
    get dnsInput(): HpcCacheDns[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): HpcCacheTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: HpcCacheTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): HpcCacheTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
