import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IotSecuritySolutionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#display_name IotSecuritySolution#display_name}.
     *
     * @stability stable
     */
    readonly displayName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#enabled IotSecuritySolution#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#events_to_export IotSecuritySolution#events_to_export}.
     *
     * @stability stable
     */
    readonly eventsToExport?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#iothub_ids IotSecuritySolution#iothub_ids}.
     *
     * @stability stable
     */
    readonly iothubIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#location IotSecuritySolution#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#log_analytics_workspace_id IotSecuritySolution#log_analytics_workspace_id}.
     *
     * @stability stable
     */
    readonly logAnalyticsWorkspaceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#log_unmasked_ips_enabled IotSecuritySolution#log_unmasked_ips_enabled}.
     *
     * @stability stable
     */
    readonly logUnmaskedIpsEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#name IotSecuritySolution#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#query_for_resources IotSecuritySolution#query_for_resources}.
     *
     * @stability stable
     */
    readonly queryForResources?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#query_subscription_ids IotSecuritySolution#query_subscription_ids}.
     *
     * @stability stable
     */
    readonly querySubscriptionIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#resource_group_name IotSecuritySolution#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#tags IotSecuritySolution#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * recommendations_enabled block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#recommendations_enabled IotSecuritySolution#recommendations_enabled}
     *
     * @stability stable
     */
    readonly recommendationsEnabled?: IotSecuritySolutionRecommendationsEnabled[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#timeouts IotSecuritySolution#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: IotSecuritySolutionTimeouts;
}
/**
 * @stability stable
 */
export interface IotSecuritySolutionRecommendationsEnabled {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#acr_authentication IotSecuritySolution#acr_authentication}.
     *
     * @stability stable
     */
    readonly acrAuthentication?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#agent_send_unutilized_msg IotSecuritySolution#agent_send_unutilized_msg}.
     *
     * @stability stable
     */
    readonly agentSendUnutilizedMsg?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#baseline IotSecuritySolution#baseline}.
     *
     * @stability stable
     */
    readonly baseline?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#edge_hub_mem_optimize IotSecuritySolution#edge_hub_mem_optimize}.
     *
     * @stability stable
     */
    readonly edgeHubMemOptimize?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#edge_logging_option IotSecuritySolution#edge_logging_option}.
     *
     * @stability stable
     */
    readonly edgeLoggingOption?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#inconsistent_module_settings IotSecuritySolution#inconsistent_module_settings}.
     *
     * @stability stable
     */
    readonly inconsistentModuleSettings?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#install_agent IotSecuritySolution#install_agent}.
     *
     * @stability stable
     */
    readonly installAgent?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#ip_filter_deny_all IotSecuritySolution#ip_filter_deny_all}.
     *
     * @stability stable
     */
    readonly ipFilterDenyAll?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#ip_filter_permissive_rule IotSecuritySolution#ip_filter_permissive_rule}.
     *
     * @stability stable
     */
    readonly ipFilterPermissiveRule?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#open_ports IotSecuritySolution#open_ports}.
     *
     * @stability stable
     */
    readonly openPorts?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#permissive_firewall_policy IotSecuritySolution#permissive_firewall_policy}.
     *
     * @stability stable
     */
    readonly permissiveFirewallPolicy?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#permissive_input_firewall_rules IotSecuritySolution#permissive_input_firewall_rules}.
     *
     * @stability stable
     */
    readonly permissiveInputFirewallRules?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#permissive_output_firewall_rules IotSecuritySolution#permissive_output_firewall_rules}.
     *
     * @stability stable
     */
    readonly permissiveOutputFirewallRules?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#privileged_docker_options IotSecuritySolution#privileged_docker_options}.
     *
     * @stability stable
     */
    readonly privilegedDockerOptions?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#shared_credentials IotSecuritySolution#shared_credentials}.
     *
     * @stability stable
     */
    readonly sharedCredentials?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#vulnerable_tls_cipher_suite IotSecuritySolution#vulnerable_tls_cipher_suite}.
     *
     * @stability stable
     */
    readonly vulnerableTlsCipherSuite?: boolean;
}
/**
 * @stability stable
 */
export interface IotSecuritySolutionTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#create IotSecuritySolution#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#delete IotSecuritySolution#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#read IotSecuritySolution#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html#update IotSecuritySolution#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html azurerm_iot_security_solution}.
 *
 * @stability stable
 */
export declare class IotSecuritySolution extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/iot_security_solution.html azurerm_iot_security_solution} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IotSecuritySolutionConfig);
    private _displayName;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    get displayNameInput(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    private _eventsToExport?;
    /**
     * @stability stable
     */
    get eventsToExport(): string[];
    /**
     * @stability stable
     */
    set eventsToExport(value: string[]);
    /**
     * @stability stable
     */
    resetEventsToExport(): void;
    /**
     * @stability stable
     */
    get eventsToExportInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _iothubIds;
    /**
     * @stability stable
     */
    get iothubIds(): string[];
    /**
     * @stability stable
     */
    set iothubIds(value: string[]);
    /**
     * @stability stable
     */
    get iothubIdsInput(): string[];
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _logAnalyticsWorkspaceId?;
    /**
     * @stability stable
     */
    get logAnalyticsWorkspaceId(): string;
    /**
     * @stability stable
     */
    set logAnalyticsWorkspaceId(value: string);
    /**
     * @stability stable
     */
    resetLogAnalyticsWorkspaceId(): void;
    /**
     * @stability stable
     */
    get logAnalyticsWorkspaceIdInput(): string | undefined;
    private _logUnmaskedIpsEnabled?;
    /**
     * @stability stable
     */
    get logUnmaskedIpsEnabled(): boolean;
    /**
     * @stability stable
     */
    set logUnmaskedIpsEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetLogUnmaskedIpsEnabled(): void;
    /**
     * @stability stable
     */
    get logUnmaskedIpsEnabledInput(): boolean | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _queryForResources?;
    /**
     * @stability stable
     */
    get queryForResources(): string;
    /**
     * @stability stable
     */
    set queryForResources(value: string);
    /**
     * @stability stable
     */
    resetQueryForResources(): void;
    /**
     * @stability stable
     */
    get queryForResourcesInput(): string | undefined;
    private _querySubscriptionIds?;
    /**
     * @stability stable
     */
    get querySubscriptionIds(): string[];
    /**
     * @stability stable
     */
    set querySubscriptionIds(value: string[]);
    /**
     * @stability stable
     */
    resetQuerySubscriptionIds(): void;
    /**
     * @stability stable
     */
    get querySubscriptionIdsInput(): string[] | undefined;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _recommendationsEnabled?;
    /**
     * @stability stable
     */
    get recommendationsEnabled(): IotSecuritySolutionRecommendationsEnabled[];
    /**
     * @stability stable
     */
    set recommendationsEnabled(value: IotSecuritySolutionRecommendationsEnabled[]);
    /**
     * @stability stable
     */
    resetRecommendationsEnabled(): void;
    /**
     * @stability stable
     */
    get recommendationsEnabledInput(): IotSecuritySolutionRecommendationsEnabled[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): IotSecuritySolutionTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: IotSecuritySolutionTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): IotSecuritySolutionTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
