import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface KeyVaultCertificateConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#key_vault_id KeyVaultCertificate#key_vault_id}.
     *
     * @stability stable
     */
    readonly keyVaultId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#name KeyVaultCertificate#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#tags KeyVaultCertificate#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * certificate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#certificate KeyVaultCertificate#certificate}
     *
     * @stability stable
     */
    readonly certificate?: KeyVaultCertificateCertificate[];
    /**
     * certificate_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#certificate_policy KeyVaultCertificate#certificate_policy}
     *
     * @stability stable
     */
    readonly certificatePolicy: KeyVaultCertificateCertificatePolicy[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#timeouts KeyVaultCertificate#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: KeyVaultCertificateTimeouts;
}
/**
 * @stability stable
 */
export declare class KeyVaultCertificateCertificateAttribute extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get created(): string;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    get expires(): string;
    /**
     * @stability stable
     */
    get notBefore(): string;
    /**
     * @stability stable
     */
    get recoveryLevel(): string;
    /**
     * @stability stable
     */
    get updated(): string;
}
/**
 * @stability stable
 */
export interface KeyVaultCertificateCertificate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#contents KeyVaultCertificate#contents}.
     *
     * @stability stable
     */
    readonly contents: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#password KeyVaultCertificate#password}.
     *
     * @stability stable
     */
    readonly password?: string;
}
/**
 * @stability stable
 */
export interface KeyVaultCertificateCertificatePolicyIssuerParameters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#name KeyVaultCertificate#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface KeyVaultCertificateCertificatePolicyKeyProperties {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#curve KeyVaultCertificate#curve}.
     *
     * @stability stable
     */
    readonly curve?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#exportable KeyVaultCertificate#exportable}.
     *
     * @stability stable
     */
    readonly exportable: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#key_size KeyVaultCertificate#key_size}.
     *
     * @stability stable
     */
    readonly keySize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#key_type KeyVaultCertificate#key_type}.
     *
     * @stability stable
     */
    readonly keyType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#reuse_key KeyVaultCertificate#reuse_key}.
     *
     * @stability stable
     */
    readonly reuseKey: boolean;
}
/**
 * @stability stable
 */
export interface KeyVaultCertificateCertificatePolicyLifetimeActionAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#action_type KeyVaultCertificate#action_type}.
     *
     * @stability stable
     */
    readonly actionType: string;
}
/**
 * @stability stable
 */
export interface KeyVaultCertificateCertificatePolicyLifetimeActionTrigger {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#days_before_expiry KeyVaultCertificate#days_before_expiry}.
     *
     * @stability stable
     */
    readonly daysBeforeExpiry?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#lifetime_percentage KeyVaultCertificate#lifetime_percentage}.
     *
     * @stability stable
     */
    readonly lifetimePercentage?: number;
}
/**
 * @stability stable
 */
export interface KeyVaultCertificateCertificatePolicyLifetimeAction {
    /**
     * action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#action KeyVaultCertificate#action}
     *
     * @stability stable
     */
    readonly action: KeyVaultCertificateCertificatePolicyLifetimeActionAction[];
    /**
     * trigger block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#trigger KeyVaultCertificate#trigger}
     *
     * @stability stable
     */
    readonly trigger: KeyVaultCertificateCertificatePolicyLifetimeActionTrigger[];
}
/**
 * @stability stable
 */
export interface KeyVaultCertificateCertificatePolicySecretProperties {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#content_type KeyVaultCertificate#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
}
/**
 * @stability stable
 */
export interface KeyVaultCertificateCertificatePolicyX509CertificatePropertiesSubjectAlternativeNames {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#dns_names KeyVaultCertificate#dns_names}.
     *
     * @stability stable
     */
    readonly dnsNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#emails KeyVaultCertificate#emails}.
     *
     * @stability stable
     */
    readonly emails?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#upns KeyVaultCertificate#upns}.
     *
     * @stability stable
     */
    readonly upns?: string[];
}
/**
 * @stability stable
 */
export interface KeyVaultCertificateCertificatePolicyX509CertificateProperties {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#extended_key_usage KeyVaultCertificate#extended_key_usage}.
     *
     * @stability stable
     */
    readonly extendedKeyUsage?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#key_usage KeyVaultCertificate#key_usage}.
     *
     * @stability stable
     */
    readonly keyUsage: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#subject KeyVaultCertificate#subject}.
     *
     * @stability stable
     */
    readonly subject: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#validity_in_months KeyVaultCertificate#validity_in_months}.
     *
     * @stability stable
     */
    readonly validityInMonths: number;
    /**
     * subject_alternative_names block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#subject_alternative_names KeyVaultCertificate#subject_alternative_names}
     *
     * @stability stable
     */
    readonly subjectAlternativeNames?: KeyVaultCertificateCertificatePolicyX509CertificatePropertiesSubjectAlternativeNames[];
}
/**
 * @stability stable
 */
export interface KeyVaultCertificateCertificatePolicy {
    /**
     * issuer_parameters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#issuer_parameters KeyVaultCertificate#issuer_parameters}
     *
     * @stability stable
     */
    readonly issuerParameters: KeyVaultCertificateCertificatePolicyIssuerParameters[];
    /**
     * key_properties block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#key_properties KeyVaultCertificate#key_properties}
     *
     * @stability stable
     */
    readonly keyProperties: KeyVaultCertificateCertificatePolicyKeyProperties[];
    /**
     * lifetime_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#lifetime_action KeyVaultCertificate#lifetime_action}
     *
     * @stability stable
     */
    readonly lifetimeAction?: KeyVaultCertificateCertificatePolicyLifetimeAction[];
    /**
     * secret_properties block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#secret_properties KeyVaultCertificate#secret_properties}
     *
     * @stability stable
     */
    readonly secretProperties: KeyVaultCertificateCertificatePolicySecretProperties[];
    /**
     * x509_certificate_properties block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#x509_certificate_properties KeyVaultCertificate#x509_certificate_properties}
     *
     * @stability stable
     */
    readonly x509CertificateProperties?: KeyVaultCertificateCertificatePolicyX509CertificateProperties[];
}
/**
 * @stability stable
 */
export interface KeyVaultCertificateTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#create KeyVaultCertificate#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#delete KeyVaultCertificate#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html#read KeyVaultCertificate#read}.
     *
     * @stability stable
     */
    readonly read?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html azurerm_key_vault_certificate}.
 *
 * @stability stable
 */
export declare class KeyVaultCertificate extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/key_vault_certificate.html azurerm_key_vault_certificate} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: KeyVaultCertificateConfig);
    /**
     * @stability stable
     */
    certificateAttribute(index: string): KeyVaultCertificateCertificateAttribute;
    /**
     * @stability stable
     */
    get certificateData(): string;
    /**
     * @stability stable
     */
    get certificateDataBase64(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _keyVaultId;
    /**
     * @stability stable
     */
    get keyVaultId(): string;
    /**
     * @stability stable
     */
    set keyVaultId(value: string);
    /**
     * @stability stable
     */
    get keyVaultIdInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get secretId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get thumbprint(): string;
    /**
     * @stability stable
     */
    get version(): string;
    private _certificate?;
    /**
     * @stability stable
     */
    get certificate(): KeyVaultCertificateCertificate[];
    /**
     * @stability stable
     */
    set certificate(value: KeyVaultCertificateCertificate[]);
    /**
     * @stability stable
     */
    resetCertificate(): void;
    /**
     * @stability stable
     */
    get certificateInput(): KeyVaultCertificateCertificate[] | undefined;
    private _certificatePolicy;
    /**
     * @stability stable
     */
    get certificatePolicy(): KeyVaultCertificateCertificatePolicy[];
    /**
     * @stability stable
     */
    set certificatePolicy(value: KeyVaultCertificateCertificatePolicy[]);
    /**
     * @stability stable
     */
    get certificatePolicyInput(): KeyVaultCertificateCertificatePolicy[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): KeyVaultCertificateTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: KeyVaultCertificateTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): KeyVaultCertificateTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
