import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MediaAssetFilterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#asset_id MediaAssetFilter#asset_id}.
     *
     * @stability stable
     */
    readonly assetId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#first_quality_bitrate MediaAssetFilter#first_quality_bitrate}.
     *
     * @stability stable
     */
    readonly firstQualityBitrate?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#name MediaAssetFilter#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * presentation_time_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#presentation_time_range MediaAssetFilter#presentation_time_range}
     *
     * @stability stable
     */
    readonly presentationTimeRange?: MediaAssetFilterPresentationTimeRange[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#timeouts MediaAssetFilter#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: MediaAssetFilterTimeouts;
    /**
     * track_selection block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#track_selection MediaAssetFilter#track_selection}
     *
     * @stability stable
     */
    readonly trackSelection?: MediaAssetFilterTrackSelection[];
}
/**
 * @stability stable
 */
export interface MediaAssetFilterPresentationTimeRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#end_in_units MediaAssetFilter#end_in_units}.
     *
     * @stability stable
     */
    readonly endInUnits?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#force_end MediaAssetFilter#force_end}.
     *
     * @stability stable
     */
    readonly forceEnd?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#live_backoff_in_units MediaAssetFilter#live_backoff_in_units}.
     *
     * @stability stable
     */
    readonly liveBackoffInUnits?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#presentation_window_in_units MediaAssetFilter#presentation_window_in_units}.
     *
     * @stability stable
     */
    readonly presentationWindowInUnits?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#start_in_units MediaAssetFilter#start_in_units}.
     *
     * @stability stable
     */
    readonly startInUnits?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#unit_timescale_in_miliseconds MediaAssetFilter#unit_timescale_in_miliseconds}.
     *
     * @stability stable
     */
    readonly unitTimescaleInMiliseconds?: number;
}
/**
 * @stability stable
 */
export interface MediaAssetFilterTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#create MediaAssetFilter#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#delete MediaAssetFilter#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#read MediaAssetFilter#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#update MediaAssetFilter#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export interface MediaAssetFilterTrackSelectionCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#operation MediaAssetFilter#operation}.
     *
     * @stability stable
     */
    readonly operation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#property MediaAssetFilter#property}.
     *
     * @stability stable
     */
    readonly property?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#value MediaAssetFilter#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface MediaAssetFilterTrackSelection {
    /**
     * condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html#condition MediaAssetFilter#condition}
     *
     * @stability stable
     */
    readonly condition: MediaAssetFilterTrackSelectionCondition[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html azurerm_media_asset_filter}.
 *
 * @stability stable
 */
export declare class MediaAssetFilter extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/media_asset_filter.html azurerm_media_asset_filter} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MediaAssetFilterConfig);
    private _assetId;
    /**
     * @stability stable
     */
    get assetId(): string;
    /**
     * @stability stable
     */
    set assetId(value: string);
    /**
     * @stability stable
     */
    get assetIdInput(): string;
    private _firstQualityBitrate?;
    /**
     * @stability stable
     */
    get firstQualityBitrate(): number;
    /**
     * @stability stable
     */
    set firstQualityBitrate(value: number);
    /**
     * @stability stable
     */
    resetFirstQualityBitrate(): void;
    /**
     * @stability stable
     */
    get firstQualityBitrateInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _presentationTimeRange?;
    /**
     * @stability stable
     */
    get presentationTimeRange(): MediaAssetFilterPresentationTimeRange[];
    /**
     * @stability stable
     */
    set presentationTimeRange(value: MediaAssetFilterPresentationTimeRange[]);
    /**
     * @stability stable
     */
    resetPresentationTimeRange(): void;
    /**
     * @stability stable
     */
    get presentationTimeRangeInput(): MediaAssetFilterPresentationTimeRange[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): MediaAssetFilterTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: MediaAssetFilterTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): MediaAssetFilterTimeouts | undefined;
    private _trackSelection?;
    /**
     * @stability stable
     */
    get trackSelection(): MediaAssetFilterTrackSelection[];
    /**
     * @stability stable
     */
    set trackSelection(value: MediaAssetFilterTrackSelection[]);
    /**
     * @stability stable
     */
    resetTrackSelection(): void;
    /**
     * @stability stable
     */
    get trackSelectionInput(): MediaAssetFilterTrackSelection[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
