import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface NetworkInterfaceBackendAddressPoolAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_interface_backend_address_pool_association.html#backend_address_pool_id NetworkInterfaceBackendAddressPoolAssociation#backend_address_pool_id}.
     *
     * @stability stable
     */
    readonly backendAddressPoolId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_interface_backend_address_pool_association.html#ip_configuration_name NetworkInterfaceBackendAddressPoolAssociation#ip_configuration_name}.
     *
     * @stability stable
     */
    readonly ipConfigurationName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_interface_backend_address_pool_association.html#network_interface_id NetworkInterfaceBackendAddressPoolAssociation#network_interface_id}.
     *
     * @stability stable
     */
    readonly networkInterfaceId: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_interface_backend_address_pool_association.html#timeouts NetworkInterfaceBackendAddressPoolAssociation#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: NetworkInterfaceBackendAddressPoolAssociationTimeouts;
}
/**
 * @stability stable
 */
export interface NetworkInterfaceBackendAddressPoolAssociationTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_interface_backend_address_pool_association.html#create NetworkInterfaceBackendAddressPoolAssociation#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_interface_backend_address_pool_association.html#delete NetworkInterfaceBackendAddressPoolAssociation#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_interface_backend_address_pool_association.html#read NetworkInterfaceBackendAddressPoolAssociation#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/network_interface_backend_address_pool_association.html#update NetworkInterfaceBackendAddressPoolAssociation#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/network_interface_backend_address_pool_association.html azurerm_network_interface_backend_address_pool_association}.
 *
 * @stability stable
 */
export declare class NetworkInterfaceBackendAddressPoolAssociation extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/network_interface_backend_address_pool_association.html azurerm_network_interface_backend_address_pool_association} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NetworkInterfaceBackendAddressPoolAssociationConfig);
    private _backendAddressPoolId;
    /**
     * @stability stable
     */
    get backendAddressPoolId(): string;
    /**
     * @stability stable
     */
    set backendAddressPoolId(value: string);
    /**
     * @stability stable
     */
    get backendAddressPoolIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _ipConfigurationName;
    /**
     * @stability stable
     */
    get ipConfigurationName(): string;
    /**
     * @stability stable
     */
    set ipConfigurationName(value: string);
    /**
     * @stability stable
     */
    get ipConfigurationNameInput(): string;
    private _networkInterfaceId;
    /**
     * @stability stable
     */
    get networkInterfaceId(): string;
    /**
     * @stability stable
     */
    set networkInterfaceId(value: string);
    /**
     * @stability stable
     */
    get networkInterfaceIdInput(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): NetworkInterfaceBackendAddressPoolAssociationTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: NetworkInterfaceBackendAddressPoolAssociationTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): NetworkInterfaceBackendAddressPoolAssociationTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
