import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SecurityCenterAssessmentMetadataConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html#description SecurityCenterAssessmentMetadata#description}.
     *
     * @stability stable
     */
    readonly description: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html#display_name SecurityCenterAssessmentMetadata#display_name}.
     *
     * @stability stable
     */
    readonly displayName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html#implementation_effort SecurityCenterAssessmentMetadata#implementation_effort}.
     *
     * @stability stable
     */
    readonly implementationEffort?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html#remediation_description SecurityCenterAssessmentMetadata#remediation_description}.
     *
     * @stability stable
     */
    readonly remediationDescription?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html#severity SecurityCenterAssessmentMetadata#severity}.
     *
     * @stability stable
     */
    readonly severity?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html#threats SecurityCenterAssessmentMetadata#threats}.
     *
     * @stability stable
     */
    readonly threats?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html#user_impact SecurityCenterAssessmentMetadata#user_impact}.
     *
     * @stability stable
     */
    readonly userImpact?: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html#timeouts SecurityCenterAssessmentMetadata#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: SecurityCenterAssessmentMetadataTimeouts;
}
/**
 * @stability stable
 */
export interface SecurityCenterAssessmentMetadataTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html#create SecurityCenterAssessmentMetadata#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html#delete SecurityCenterAssessmentMetadata#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html#read SecurityCenterAssessmentMetadata#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html#update SecurityCenterAssessmentMetadata#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html azurerm_security_center_assessment_metadata}.
 *
 * @stability stable
 */
export declare class SecurityCenterAssessmentMetadata extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment_metadata.html azurerm_security_center_assessment_metadata} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SecurityCenterAssessmentMetadataConfig);
    private _description;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    get descriptionInput(): string;
    private _displayName;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    get displayNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _implementationEffort?;
    /**
     * @stability stable
     */
    get implementationEffort(): string;
    /**
     * @stability stable
     */
    set implementationEffort(value: string);
    /**
     * @stability stable
     */
    resetImplementationEffort(): void;
    /**
     * @stability stable
     */
    get implementationEffortInput(): string | undefined;
    /**
     * @stability stable
     */
    get name(): string;
    private _remediationDescription?;
    /**
     * @stability stable
     */
    get remediationDescription(): string;
    /**
     * @stability stable
     */
    set remediationDescription(value: string);
    /**
     * @stability stable
     */
    resetRemediationDescription(): void;
    /**
     * @stability stable
     */
    get remediationDescriptionInput(): string | undefined;
    private _severity?;
    /**
     * @stability stable
     */
    get severity(): string;
    /**
     * @stability stable
     */
    set severity(value: string);
    /**
     * @stability stable
     */
    resetSeverity(): void;
    /**
     * @stability stable
     */
    get severityInput(): string | undefined;
    private _threats?;
    /**
     * @stability stable
     */
    get threats(): string[];
    /**
     * @stability stable
     */
    set threats(value: string[]);
    /**
     * @stability stable
     */
    resetThreats(): void;
    /**
     * @stability stable
     */
    get threatsInput(): string[] | undefined;
    private _userImpact?;
    /**
     * @stability stable
     */
    get userImpact(): string;
    /**
     * @stability stable
     */
    set userImpact(value: string);
    /**
     * @stability stable
     */
    resetUserImpact(): void;
    /**
     * @stability stable
     */
    get userImpactInput(): string | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): SecurityCenterAssessmentMetadataTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: SecurityCenterAssessmentMetadataTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): SecurityCenterAssessmentMetadataTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
