import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SecurityCenterAssessmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html#additional_data SecurityCenterAssessment#additional_data}.
     *
     * @stability stable
     */
    readonly additionalData?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html#assessment_policy_id SecurityCenterAssessment#assessment_policy_id}.
     *
     * @stability stable
     */
    readonly assessmentPolicyId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html#target_resource_id SecurityCenterAssessment#target_resource_id}.
     *
     * @stability stable
     */
    readonly targetResourceId: string;
    /**
     * status block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html#status SecurityCenterAssessment#status}
     *
     * @stability stable
     */
    readonly status: SecurityCenterAssessmentStatus[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html#timeouts SecurityCenterAssessment#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: SecurityCenterAssessmentTimeouts;
}
/**
 * @stability stable
 */
export interface SecurityCenterAssessmentStatus {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html#cause SecurityCenterAssessment#cause}.
     *
     * @stability stable
     */
    readonly cause?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html#code SecurityCenterAssessment#code}.
     *
     * @stability stable
     */
    readonly code: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html#description SecurityCenterAssessment#description}.
     *
     * @stability stable
     */
    readonly description?: string;
}
/**
 * @stability stable
 */
export interface SecurityCenterAssessmentTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html#create SecurityCenterAssessment#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html#delete SecurityCenterAssessment#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html#read SecurityCenterAssessment#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html#update SecurityCenterAssessment#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html azurerm_security_center_assessment}.
 *
 * @stability stable
 */
export declare class SecurityCenterAssessment extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_assessment.html azurerm_security_center_assessment} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SecurityCenterAssessmentConfig);
    private _additionalData?;
    /**
     * @stability stable
     */
    get additionalData(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set additionalData(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetAdditionalData(): void;
    /**
     * @stability stable
     */
    get additionalDataInput(): {
        [key: string]: string;
    } | undefined;
    private _assessmentPolicyId;
    /**
     * @stability stable
     */
    get assessmentPolicyId(): string;
    /**
     * @stability stable
     */
    set assessmentPolicyId(value: string);
    /**
     * @stability stable
     */
    get assessmentPolicyIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _targetResourceId;
    /**
     * @stability stable
     */
    get targetResourceId(): string;
    /**
     * @stability stable
     */
    set targetResourceId(value: string);
    /**
     * @stability stable
     */
    get targetResourceIdInput(): string;
    private _status;
    /**
     * @stability stable
     */
    get status(): SecurityCenterAssessmentStatus[];
    /**
     * @stability stable
     */
    set status(value: SecurityCenterAssessmentStatus[]);
    /**
     * @stability stable
     */
    get statusInput(): SecurityCenterAssessmentStatus[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): SecurityCenterAssessmentTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: SecurityCenterAssessmentTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): SecurityCenterAssessmentTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
