import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VirtualHubConnectionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#hub_to_vitual_network_traffic_allowed VirtualHubConnection#hub_to_vitual_network_traffic_allowed}.
     *
     * @stability stable
     */
    readonly hubToVitualNetworkTrafficAllowed?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#internet_security_enabled VirtualHubConnection#internet_security_enabled}.
     *
     * @stability stable
     */
    readonly internetSecurityEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#name VirtualHubConnection#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#remote_virtual_network_id VirtualHubConnection#remote_virtual_network_id}.
     *
     * @stability stable
     */
    readonly remoteVirtualNetworkId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#virtual_hub_id VirtualHubConnection#virtual_hub_id}.
     *
     * @stability stable
     */
    readonly virtualHubId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#vitual_network_to_hub_gateways_traffic_allowed VirtualHubConnection#vitual_network_to_hub_gateways_traffic_allowed}.
     *
     * @stability stable
     */
    readonly vitualNetworkToHubGatewaysTrafficAllowed?: boolean;
    /**
     * routing block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#routing VirtualHubConnection#routing}
     *
     * @stability stable
     */
    readonly routing?: VirtualHubConnectionRouting[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#timeouts VirtualHubConnection#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: VirtualHubConnectionTimeouts;
}
/**
 * @stability stable
 */
export interface VirtualHubConnectionRoutingPropagatedRouteTable {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#labels VirtualHubConnection#labels}.
     *
     * @stability stable
     */
    readonly labels?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#route_table_ids VirtualHubConnection#route_table_ids}.
     *
     * @stability stable
     */
    readonly routeTableIds?: string[];
}
/**
 * @stability stable
 */
export interface VirtualHubConnectionRoutingStaticVnetRoute {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#address_prefixes VirtualHubConnection#address_prefixes}.
     *
     * @stability stable
     */
    readonly addressPrefixes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#name VirtualHubConnection#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#next_hop_ip_address VirtualHubConnection#next_hop_ip_address}.
     *
     * @stability stable
     */
    readonly nextHopIpAddress?: string;
}
/**
 * @stability stable
 */
export interface VirtualHubConnectionRouting {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#associated_route_table_id VirtualHubConnection#associated_route_table_id}.
     *
     * @stability stable
     */
    readonly associatedRouteTableId?: string;
    /**
     * propagated_route_table block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#propagated_route_table VirtualHubConnection#propagated_route_table}
     *
     * @stability stable
     */
    readonly propagatedRouteTable?: VirtualHubConnectionRoutingPropagatedRouteTable[];
    /**
     * static_vnet_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#static_vnet_route VirtualHubConnection#static_vnet_route}
     *
     * @stability stable
     */
    readonly staticVnetRoute?: VirtualHubConnectionRoutingStaticVnetRoute[];
}
/**
 * @stability stable
 */
export interface VirtualHubConnectionTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#create VirtualHubConnection#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#delete VirtualHubConnection#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#read VirtualHubConnection#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html#update VirtualHubConnection#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html azurerm_virtual_hub_connection}.
 *
 * @stability stable
 */
export declare class VirtualHubConnection extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_hub_connection.html azurerm_virtual_hub_connection} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VirtualHubConnectionConfig);
    private _hubToVitualNetworkTrafficAllowed?;
    /**
     * @stability stable
     */
    get hubToVitualNetworkTrafficAllowed(): boolean;
    /**
     * @stability stable
     */
    set hubToVitualNetworkTrafficAllowed(value: boolean);
    /**
     * @stability stable
     */
    resetHubToVitualNetworkTrafficAllowed(): void;
    /**
     * @stability stable
     */
    get hubToVitualNetworkTrafficAllowedInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _internetSecurityEnabled?;
    /**
     * @stability stable
     */
    get internetSecurityEnabled(): boolean;
    /**
     * @stability stable
     */
    set internetSecurityEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetInternetSecurityEnabled(): void;
    /**
     * @stability stable
     */
    get internetSecurityEnabledInput(): boolean | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _remoteVirtualNetworkId;
    /**
     * @stability stable
     */
    get remoteVirtualNetworkId(): string;
    /**
     * @stability stable
     */
    set remoteVirtualNetworkId(value: string);
    /**
     * @stability stable
     */
    get remoteVirtualNetworkIdInput(): string;
    private _virtualHubId;
    /**
     * @stability stable
     */
    get virtualHubId(): string;
    /**
     * @stability stable
     */
    set virtualHubId(value: string);
    /**
     * @stability stable
     */
    get virtualHubIdInput(): string;
    private _vitualNetworkToHubGatewaysTrafficAllowed?;
    /**
     * @stability stable
     */
    get vitualNetworkToHubGatewaysTrafficAllowed(): boolean;
    /**
     * @stability stable
     */
    set vitualNetworkToHubGatewaysTrafficAllowed(value: boolean);
    /**
     * @stability stable
     */
    resetVitualNetworkToHubGatewaysTrafficAllowed(): void;
    /**
     * @stability stable
     */
    get vitualNetworkToHubGatewaysTrafficAllowedInput(): boolean | undefined;
    private _routing?;
    /**
     * @stability stable
     */
    get routing(): VirtualHubConnectionRouting[];
    /**
     * @stability stable
     */
    set routing(value: VirtualHubConnectionRouting[]);
    /**
     * @stability stable
     */
    resetRouting(): void;
    /**
     * @stability stable
     */
    get routingInput(): VirtualHubConnectionRouting[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): VirtualHubConnectionTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: VirtualHubConnectionTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): VirtualHubConnectionTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
