import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VirtualNetworkGatewayConnectionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#authorization_key VirtualNetworkGatewayConnection#authorization_key}.
     *
     * @stability stable
     */
    readonly authorizationKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#connection_protocol VirtualNetworkGatewayConnection#connection_protocol}.
     *
     * @stability stable
     */
    readonly connectionProtocol?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#dpd_timeout_seconds VirtualNetworkGatewayConnection#dpd_timeout_seconds}.
     *
     * @stability stable
     */
    readonly dpdTimeoutSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#enable_bgp VirtualNetworkGatewayConnection#enable_bgp}.
     *
     * @stability stable
     */
    readonly enableBgp?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#express_route_circuit_id VirtualNetworkGatewayConnection#express_route_circuit_id}.
     *
     * @stability stable
     */
    readonly expressRouteCircuitId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#express_route_gateway_bypass VirtualNetworkGatewayConnection#express_route_gateway_bypass}.
     *
     * @stability stable
     */
    readonly expressRouteGatewayBypass?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#local_azure_ip_address_enabled VirtualNetworkGatewayConnection#local_azure_ip_address_enabled}.
     *
     * @stability stable
     */
    readonly localAzureIpAddressEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#local_network_gateway_id VirtualNetworkGatewayConnection#local_network_gateway_id}.
     *
     * @stability stable
     */
    readonly localNetworkGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#location VirtualNetworkGatewayConnection#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#name VirtualNetworkGatewayConnection#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#peer_virtual_network_gateway_id VirtualNetworkGatewayConnection#peer_virtual_network_gateway_id}.
     *
     * @stability stable
     */
    readonly peerVirtualNetworkGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#resource_group_name VirtualNetworkGatewayConnection#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#routing_weight VirtualNetworkGatewayConnection#routing_weight}.
     *
     * @stability stable
     */
    readonly routingWeight?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#shared_key VirtualNetworkGatewayConnection#shared_key}.
     *
     * @stability stable
     */
    readonly sharedKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#tags VirtualNetworkGatewayConnection#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#type VirtualNetworkGatewayConnection#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#use_policy_based_traffic_selectors VirtualNetworkGatewayConnection#use_policy_based_traffic_selectors}.
     *
     * @stability stable
     */
    readonly usePolicyBasedTrafficSelectors?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#virtual_network_gateway_id VirtualNetworkGatewayConnection#virtual_network_gateway_id}.
     *
     * @stability stable
     */
    readonly virtualNetworkGatewayId: string;
    /**
     * ipsec_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#ipsec_policy VirtualNetworkGatewayConnection#ipsec_policy}
     *
     * @stability stable
     */
    readonly ipsecPolicy?: VirtualNetworkGatewayConnectionIpsecPolicy[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#timeouts VirtualNetworkGatewayConnection#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: VirtualNetworkGatewayConnectionTimeouts;
    /**
     * traffic_selector_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#traffic_selector_policy VirtualNetworkGatewayConnection#traffic_selector_policy}
     *
     * @stability stable
     */
    readonly trafficSelectorPolicy?: VirtualNetworkGatewayConnectionTrafficSelectorPolicy[];
}
/**
 * @stability stable
 */
export interface VirtualNetworkGatewayConnectionIpsecPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#dh_group VirtualNetworkGatewayConnection#dh_group}.
     *
     * @stability stable
     */
    readonly dhGroup: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#ike_encryption VirtualNetworkGatewayConnection#ike_encryption}.
     *
     * @stability stable
     */
    readonly ikeEncryption: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#ike_integrity VirtualNetworkGatewayConnection#ike_integrity}.
     *
     * @stability stable
     */
    readonly ikeIntegrity: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#ipsec_encryption VirtualNetworkGatewayConnection#ipsec_encryption}.
     *
     * @stability stable
     */
    readonly ipsecEncryption: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#ipsec_integrity VirtualNetworkGatewayConnection#ipsec_integrity}.
     *
     * @stability stable
     */
    readonly ipsecIntegrity: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#pfs_group VirtualNetworkGatewayConnection#pfs_group}.
     *
     * @stability stable
     */
    readonly pfsGroup: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#sa_datasize VirtualNetworkGatewayConnection#sa_datasize}.
     *
     * @stability stable
     */
    readonly saDatasize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#sa_lifetime VirtualNetworkGatewayConnection#sa_lifetime}.
     *
     * @stability stable
     */
    readonly saLifetime?: number;
}
/**
 * @stability stable
 */
export interface VirtualNetworkGatewayConnectionTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#create VirtualNetworkGatewayConnection#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#delete VirtualNetworkGatewayConnection#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#read VirtualNetworkGatewayConnection#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#update VirtualNetworkGatewayConnection#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export interface VirtualNetworkGatewayConnectionTrafficSelectorPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#local_address_cidrs VirtualNetworkGatewayConnection#local_address_cidrs}.
     *
     * @stability stable
     */
    readonly localAddressCidrs: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html#remote_address_cidrs VirtualNetworkGatewayConnection#remote_address_cidrs}.
     *
     * @stability stable
     */
    readonly remoteAddressCidrs: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html azurerm_virtual_network_gateway_connection}.
 *
 * @stability stable
 */
export declare class VirtualNetworkGatewayConnection extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway_connection.html azurerm_virtual_network_gateway_connection} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VirtualNetworkGatewayConnectionConfig);
    private _authorizationKey?;
    /**
     * @stability stable
     */
    get authorizationKey(): string;
    /**
     * @stability stable
     */
    set authorizationKey(value: string);
    /**
     * @stability stable
     */
    resetAuthorizationKey(): void;
    /**
     * @stability stable
     */
    get authorizationKeyInput(): string | undefined;
    private _connectionProtocol?;
    /**
     * @stability stable
     */
    get connectionProtocol(): string;
    /**
     * @stability stable
     */
    set connectionProtocol(value: string);
    /**
     * @stability stable
     */
    resetConnectionProtocol(): void;
    /**
     * @stability stable
     */
    get connectionProtocolInput(): string | undefined;
    private _dpdTimeoutSeconds?;
    /**
     * @stability stable
     */
    get dpdTimeoutSeconds(): number;
    /**
     * @stability stable
     */
    set dpdTimeoutSeconds(value: number);
    /**
     * @stability stable
     */
    resetDpdTimeoutSeconds(): void;
    /**
     * @stability stable
     */
    get dpdTimeoutSecondsInput(): number | undefined;
    private _enableBgp?;
    /**
     * @stability stable
     */
    get enableBgp(): boolean;
    /**
     * @stability stable
     */
    set enableBgp(value: boolean);
    /**
     * @stability stable
     */
    resetEnableBgp(): void;
    /**
     * @stability stable
     */
    get enableBgpInput(): boolean | undefined;
    private _expressRouteCircuitId?;
    /**
     * @stability stable
     */
    get expressRouteCircuitId(): string;
    /**
     * @stability stable
     */
    set expressRouteCircuitId(value: string);
    /**
     * @stability stable
     */
    resetExpressRouteCircuitId(): void;
    /**
     * @stability stable
     */
    get expressRouteCircuitIdInput(): string | undefined;
    private _expressRouteGatewayBypass?;
    /**
     * @stability stable
     */
    get expressRouteGatewayBypass(): boolean;
    /**
     * @stability stable
     */
    set expressRouteGatewayBypass(value: boolean);
    /**
     * @stability stable
     */
    resetExpressRouteGatewayBypass(): void;
    /**
     * @stability stable
     */
    get expressRouteGatewayBypassInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _localAzureIpAddressEnabled?;
    /**
     * @stability stable
     */
    get localAzureIpAddressEnabled(): boolean;
    /**
     * @stability stable
     */
    set localAzureIpAddressEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetLocalAzureIpAddressEnabled(): void;
    /**
     * @stability stable
     */
    get localAzureIpAddressEnabledInput(): boolean | undefined;
    private _localNetworkGatewayId?;
    /**
     * @stability stable
     */
    get localNetworkGatewayId(): string;
    /**
     * @stability stable
     */
    set localNetworkGatewayId(value: string);
    /**
     * @stability stable
     */
    resetLocalNetworkGatewayId(): void;
    /**
     * @stability stable
     */
    get localNetworkGatewayIdInput(): string | undefined;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _peerVirtualNetworkGatewayId?;
    /**
     * @stability stable
     */
    get peerVirtualNetworkGatewayId(): string;
    /**
     * @stability stable
     */
    set peerVirtualNetworkGatewayId(value: string);
    /**
     * @stability stable
     */
    resetPeerVirtualNetworkGatewayId(): void;
    /**
     * @stability stable
     */
    get peerVirtualNetworkGatewayIdInput(): string | undefined;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _routingWeight?;
    /**
     * @stability stable
     */
    get routingWeight(): number;
    /**
     * @stability stable
     */
    set routingWeight(value: number);
    /**
     * @stability stable
     */
    resetRoutingWeight(): void;
    /**
     * @stability stable
     */
    get routingWeightInput(): number | undefined;
    private _sharedKey?;
    /**
     * @stability stable
     */
    get sharedKey(): string;
    /**
     * @stability stable
     */
    set sharedKey(value: string);
    /**
     * @stability stable
     */
    resetSharedKey(): void;
    /**
     * @stability stable
     */
    get sharedKeyInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    private _usePolicyBasedTrafficSelectors?;
    /**
     * @stability stable
     */
    get usePolicyBasedTrafficSelectors(): boolean;
    /**
     * @stability stable
     */
    set usePolicyBasedTrafficSelectors(value: boolean);
    /**
     * @stability stable
     */
    resetUsePolicyBasedTrafficSelectors(): void;
    /**
     * @stability stable
     */
    get usePolicyBasedTrafficSelectorsInput(): boolean | undefined;
    private _virtualNetworkGatewayId;
    /**
     * @stability stable
     */
    get virtualNetworkGatewayId(): string;
    /**
     * @stability stable
     */
    set virtualNetworkGatewayId(value: string);
    /**
     * @stability stable
     */
    get virtualNetworkGatewayIdInput(): string;
    private _ipsecPolicy?;
    /**
     * @stability stable
     */
    get ipsecPolicy(): VirtualNetworkGatewayConnectionIpsecPolicy[];
    /**
     * @stability stable
     */
    set ipsecPolicy(value: VirtualNetworkGatewayConnectionIpsecPolicy[]);
    /**
     * @stability stable
     */
    resetIpsecPolicy(): void;
    /**
     * @stability stable
     */
    get ipsecPolicyInput(): VirtualNetworkGatewayConnectionIpsecPolicy[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): VirtualNetworkGatewayConnectionTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: VirtualNetworkGatewayConnectionTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): VirtualNetworkGatewayConnectionTimeouts | undefined;
    private _trafficSelectorPolicy?;
    /**
     * @stability stable
     */
    get trafficSelectorPolicy(): VirtualNetworkGatewayConnectionTrafficSelectorPolicy[];
    /**
     * @stability stable
     */
    set trafficSelectorPolicy(value: VirtualNetworkGatewayConnectionTrafficSelectorPolicy[]);
    /**
     * @stability stable
     */
    resetTrafficSelectorPolicy(): void;
    /**
     * @stability stable
     */
    get trafficSelectorPolicyInput(): VirtualNetworkGatewayConnectionTrafficSelectorPolicy[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
