import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VirtualNetworkGatewayConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#active_active VirtualNetworkGateway#active_active}.
     *
     * @stability stable
     */
    readonly activeActive?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#default_local_network_gateway_id VirtualNetworkGateway#default_local_network_gateway_id}.
     *
     * @stability stable
     */
    readonly defaultLocalNetworkGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#enable_bgp VirtualNetworkGateway#enable_bgp}.
     *
     * @stability stable
     */
    readonly enableBgp?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#generation VirtualNetworkGateway#generation}.
     *
     * @stability stable
     */
    readonly generation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#location VirtualNetworkGateway#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#name VirtualNetworkGateway#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#private_ip_address_enabled VirtualNetworkGateway#private_ip_address_enabled}.
     *
     * @stability stable
     */
    readonly privateIpAddressEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#resource_group_name VirtualNetworkGateway#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#sku VirtualNetworkGateway#sku}.
     *
     * @stability stable
     */
    readonly sku: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#tags VirtualNetworkGateway#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#type VirtualNetworkGateway#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#vpn_type VirtualNetworkGateway#vpn_type}.
     *
     * @stability stable
     */
    readonly vpnType?: string;
    /**
     * bgp_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#bgp_settings VirtualNetworkGateway#bgp_settings}
     *
     * @stability stable
     */
    readonly bgpSettings?: VirtualNetworkGatewayBgpSettings[];
    /**
     * custom_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#custom_route VirtualNetworkGateway#custom_route}
     *
     * @stability stable
     */
    readonly customRoute?: VirtualNetworkGatewayCustomRoute[];
    /**
     * ip_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#ip_configuration VirtualNetworkGateway#ip_configuration}
     *
     * @stability stable
     */
    readonly ipConfiguration: VirtualNetworkGatewayIpConfiguration[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#timeouts VirtualNetworkGateway#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: VirtualNetworkGatewayTimeouts;
    /**
     * vpn_client_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#vpn_client_configuration VirtualNetworkGateway#vpn_client_configuration}
     *
     * @stability stable
     */
    readonly vpnClientConfiguration?: VirtualNetworkGatewayVpnClientConfiguration[];
}
/**
 * @stability stable
 */
export interface VirtualNetworkGatewayBgpSettingsPeeringAddresses {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#apipa_addresses VirtualNetworkGateway#apipa_addresses}.
     *
     * @stability stable
     */
    readonly apipaAddresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#ip_configuration_name VirtualNetworkGateway#ip_configuration_name}.
     *
     * @stability stable
     */
    readonly ipConfigurationName?: string;
}
/**
 * @stability stable
 */
export interface VirtualNetworkGatewayBgpSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#asn VirtualNetworkGateway#asn}.
     *
     * @stability stable
     */
    readonly asn?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#peer_weight VirtualNetworkGateway#peer_weight}.
     *
     * @stability stable
     */
    readonly peerWeight?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#peering_address VirtualNetworkGateway#peering_address}.
     *
     * @stability stable
     */
    readonly peeringAddress?: string;
    /**
     * peering_addresses block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#peering_addresses VirtualNetworkGateway#peering_addresses}
     *
     * @stability stable
     */
    readonly peeringAddresses?: VirtualNetworkGatewayBgpSettingsPeeringAddresses[];
}
/**
 * @stability stable
 */
export interface VirtualNetworkGatewayCustomRoute {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#address_prefixes VirtualNetworkGateway#address_prefixes}.
     *
     * @stability stable
     */
    readonly addressPrefixes?: string[];
}
/**
 * @stability stable
 */
export interface VirtualNetworkGatewayIpConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#name VirtualNetworkGateway#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#private_ip_address_allocation VirtualNetworkGateway#private_ip_address_allocation}.
     *
     * @stability stable
     */
    readonly privateIpAddressAllocation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#public_ip_address_id VirtualNetworkGateway#public_ip_address_id}.
     *
     * @stability stable
     */
    readonly publicIpAddressId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#subnet_id VirtualNetworkGateway#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId: string;
}
/**
 * @stability stable
 */
export interface VirtualNetworkGatewayTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#create VirtualNetworkGateway#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#delete VirtualNetworkGateway#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#read VirtualNetworkGateway#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#update VirtualNetworkGateway#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export interface VirtualNetworkGatewayVpnClientConfigurationRevokedCertificate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#name VirtualNetworkGateway#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#thumbprint VirtualNetworkGateway#thumbprint}.
     *
     * @stability stable
     */
    readonly thumbprint: string;
}
/**
 * @stability stable
 */
export interface VirtualNetworkGatewayVpnClientConfigurationRootCertificate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#name VirtualNetworkGateway#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#public_cert_data VirtualNetworkGateway#public_cert_data}.
     *
     * @stability stable
     */
    readonly publicCertData: string;
}
/**
 * @stability stable
 */
export interface VirtualNetworkGatewayVpnClientConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#aad_audience VirtualNetworkGateway#aad_audience}.
     *
     * @stability stable
     */
    readonly aadAudience?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#aad_issuer VirtualNetworkGateway#aad_issuer}.
     *
     * @stability stable
     */
    readonly aadIssuer?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#aad_tenant VirtualNetworkGateway#aad_tenant}.
     *
     * @stability stable
     */
    readonly aadTenant?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#address_space VirtualNetworkGateway#address_space}.
     *
     * @stability stable
     */
    readonly addressSpace: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#radius_server_address VirtualNetworkGateway#radius_server_address}.
     *
     * @stability stable
     */
    readonly radiusServerAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#radius_server_secret VirtualNetworkGateway#radius_server_secret}.
     *
     * @stability stable
     */
    readonly radiusServerSecret?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#vpn_client_protocols VirtualNetworkGateway#vpn_client_protocols}.
     *
     * @stability stable
     */
    readonly vpnClientProtocols?: string[];
    /**
     * revoked_certificate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#revoked_certificate VirtualNetworkGateway#revoked_certificate}
     *
     * @stability stable
     */
    readonly revokedCertificate?: VirtualNetworkGatewayVpnClientConfigurationRevokedCertificate[];
    /**
     * root_certificate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html#root_certificate VirtualNetworkGateway#root_certificate}
     *
     * @stability stable
     */
    readonly rootCertificate?: VirtualNetworkGatewayVpnClientConfigurationRootCertificate[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html azurerm_virtual_network_gateway}.
 *
 * @stability stable
 */
export declare class VirtualNetworkGateway extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_network_gateway.html azurerm_virtual_network_gateway} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VirtualNetworkGatewayConfig);
    private _activeActive?;
    /**
     * @stability stable
     */
    get activeActive(): boolean;
    /**
     * @stability stable
     */
    set activeActive(value: boolean);
    /**
     * @stability stable
     */
    resetActiveActive(): void;
    /**
     * @stability stable
     */
    get activeActiveInput(): boolean | undefined;
    private _defaultLocalNetworkGatewayId?;
    /**
     * @stability stable
     */
    get defaultLocalNetworkGatewayId(): string;
    /**
     * @stability stable
     */
    set defaultLocalNetworkGatewayId(value: string);
    /**
     * @stability stable
     */
    resetDefaultLocalNetworkGatewayId(): void;
    /**
     * @stability stable
     */
    get defaultLocalNetworkGatewayIdInput(): string | undefined;
    private _enableBgp?;
    /**
     * @stability stable
     */
    get enableBgp(): boolean;
    /**
     * @stability stable
     */
    set enableBgp(value: boolean);
    /**
     * @stability stable
     */
    resetEnableBgp(): void;
    /**
     * @stability stable
     */
    get enableBgpInput(): boolean | undefined;
    private _generation?;
    /**
     * @stability stable
     */
    get generation(): string;
    /**
     * @stability stable
     */
    set generation(value: string);
    /**
     * @stability stable
     */
    resetGeneration(): void;
    /**
     * @stability stable
     */
    get generationInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _privateIpAddressEnabled?;
    /**
     * @stability stable
     */
    get privateIpAddressEnabled(): boolean;
    /**
     * @stability stable
     */
    set privateIpAddressEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetPrivateIpAddressEnabled(): void;
    /**
     * @stability stable
     */
    get privateIpAddressEnabledInput(): boolean | undefined;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _sku;
    /**
     * @stability stable
     */
    get sku(): string;
    /**
     * @stability stable
     */
    set sku(value: string);
    /**
     * @stability stable
     */
    get skuInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    private _vpnType?;
    /**
     * @stability stable
     */
    get vpnType(): string;
    /**
     * @stability stable
     */
    set vpnType(value: string);
    /**
     * @stability stable
     */
    resetVpnType(): void;
    /**
     * @stability stable
     */
    get vpnTypeInput(): string | undefined;
    private _bgpSettings?;
    /**
     * @stability stable
     */
    get bgpSettings(): VirtualNetworkGatewayBgpSettings[];
    /**
     * @stability stable
     */
    set bgpSettings(value: VirtualNetworkGatewayBgpSettings[]);
    /**
     * @stability stable
     */
    resetBgpSettings(): void;
    /**
     * @stability stable
     */
    get bgpSettingsInput(): VirtualNetworkGatewayBgpSettings[] | undefined;
    private _customRoute?;
    /**
     * @stability stable
     */
    get customRoute(): VirtualNetworkGatewayCustomRoute[];
    /**
     * @stability stable
     */
    set customRoute(value: VirtualNetworkGatewayCustomRoute[]);
    /**
     * @stability stable
     */
    resetCustomRoute(): void;
    /**
     * @stability stable
     */
    get customRouteInput(): VirtualNetworkGatewayCustomRoute[] | undefined;
    private _ipConfiguration;
    /**
     * @stability stable
     */
    get ipConfiguration(): VirtualNetworkGatewayIpConfiguration[];
    /**
     * @stability stable
     */
    set ipConfiguration(value: VirtualNetworkGatewayIpConfiguration[]);
    /**
     * @stability stable
     */
    get ipConfigurationInput(): VirtualNetworkGatewayIpConfiguration[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): VirtualNetworkGatewayTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: VirtualNetworkGatewayTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): VirtualNetworkGatewayTimeouts | undefined;
    private _vpnClientConfiguration?;
    /**
     * @stability stable
     */
    get vpnClientConfiguration(): VirtualNetworkGatewayVpnClientConfiguration[];
    /**
     * @stability stable
     */
    set vpnClientConfiguration(value: VirtualNetworkGatewayVpnClientConfiguration[]);
    /**
     * @stability stable
     */
    resetVpnClientConfiguration(): void;
    /**
     * @stability stable
     */
    get vpnClientConfigurationInput(): VirtualNetworkGatewayVpnClientConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
