import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VirtualWanConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#allow_branch_to_branch_traffic VirtualWan#allow_branch_to_branch_traffic}.
     *
     * @stability stable
     */
    readonly allowBranchToBranchTraffic?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#allow_vnet_to_vnet_traffic VirtualWan#allow_vnet_to_vnet_traffic}.
     *
     * @stability stable
     */
    readonly allowVnetToVnetTraffic?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#disable_vpn_encryption VirtualWan#disable_vpn_encryption}.
     *
     * @stability stable
     */
    readonly disableVpnEncryption?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#location VirtualWan#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#name VirtualWan#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#office365_local_breakout_category VirtualWan#office365_local_breakout_category}.
     *
     * @stability stable
     */
    readonly office365LocalBreakoutCategory?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#resource_group_name VirtualWan#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#tags VirtualWan#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#type VirtualWan#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#timeouts VirtualWan#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: VirtualWanTimeouts;
}
/**
 * @stability stable
 */
export interface VirtualWanTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#create VirtualWan#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#delete VirtualWan#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#read VirtualWan#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html#update VirtualWan#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html azurerm_virtual_wan}.
 *
 * @stability stable
 */
export declare class VirtualWan extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/virtual_wan.html azurerm_virtual_wan} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VirtualWanConfig);
    private _allowBranchToBranchTraffic?;
    /**
     * @stability stable
     */
    get allowBranchToBranchTraffic(): boolean;
    /**
     * @stability stable
     */
    set allowBranchToBranchTraffic(value: boolean);
    /**
     * @stability stable
     */
    resetAllowBranchToBranchTraffic(): void;
    /**
     * @stability stable
     */
    get allowBranchToBranchTrafficInput(): boolean | undefined;
    private _allowVnetToVnetTraffic?;
    /**
     * @stability stable
     */
    get allowVnetToVnetTraffic(): boolean;
    /**
     * @stability stable
     */
    set allowVnetToVnetTraffic(value: boolean);
    /**
     * @stability stable
     */
    resetAllowVnetToVnetTraffic(): void;
    /**
     * @stability stable
     */
    get allowVnetToVnetTrafficInput(): boolean | undefined;
    private _disableVpnEncryption?;
    /**
     * @stability stable
     */
    get disableVpnEncryption(): boolean;
    /**
     * @stability stable
     */
    set disableVpnEncryption(value: boolean);
    /**
     * @stability stable
     */
    resetDisableVpnEncryption(): void;
    /**
     * @stability stable
     */
    get disableVpnEncryptionInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _office365LocalBreakoutCategory?;
    /**
     * @stability stable
     */
    get office365LocalBreakoutCategory(): string;
    /**
     * @stability stable
     */
    set office365LocalBreakoutCategory(value: string);
    /**
     * @stability stable
     */
    resetOffice365LocalBreakoutCategory(): void;
    /**
     * @stability stable
     */
    get office365LocalBreakoutCategoryInput(): string | undefined;
    private _resourceGroupName;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): VirtualWanTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: VirtualWanTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): VirtualWanTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
