import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MssqlDatabaseVulnerabilityAssessmentRuleBaselineConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database_vulnerability_assessment_rule_baseline.html#baseline_name MssqlDatabaseVulnerabilityAssessmentRuleBaseline#baseline_name}.
     *
     * @stability stable
     */
    readonly baselineName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database_vulnerability_assessment_rule_baseline.html#database_name MssqlDatabaseVulnerabilityAssessmentRuleBaseline#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database_vulnerability_assessment_rule_baseline.html#rule_id MssqlDatabaseVulnerabilityAssessmentRuleBaseline#rule_id}.
     *
     * @stability stable
     */
    readonly ruleId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database_vulnerability_assessment_rule_baseline.html#server_vulnerability_assessment_id MssqlDatabaseVulnerabilityAssessmentRuleBaseline#server_vulnerability_assessment_id}.
     *
     * @stability stable
     */
    readonly serverVulnerabilityAssessmentId: string;
    /**
     * baseline_result block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database_vulnerability_assessment_rule_baseline.html#baseline_result MssqlDatabaseVulnerabilityAssessmentRuleBaseline#baseline_result}
     *
     * @stability stable
     */
    readonly baselineResult: MssqlDatabaseVulnerabilityAssessmentRuleBaselineBaselineResult[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database_vulnerability_assessment_rule_baseline.html#timeouts MssqlDatabaseVulnerabilityAssessmentRuleBaseline#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: MssqlDatabaseVulnerabilityAssessmentRuleBaselineTimeouts;
}
/**
 * @stability stable
 */
export interface MssqlDatabaseVulnerabilityAssessmentRuleBaselineBaselineResult {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database_vulnerability_assessment_rule_baseline.html#result MssqlDatabaseVulnerabilityAssessmentRuleBaseline#result}.
     *
     * @stability stable
     */
    readonly result: string[];
}
/**
 * @stability stable
 */
export interface MssqlDatabaseVulnerabilityAssessmentRuleBaselineTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database_vulnerability_assessment_rule_baseline.html#create MssqlDatabaseVulnerabilityAssessmentRuleBaseline#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database_vulnerability_assessment_rule_baseline.html#delete MssqlDatabaseVulnerabilityAssessmentRuleBaseline#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database_vulnerability_assessment_rule_baseline.html#read MssqlDatabaseVulnerabilityAssessmentRuleBaseline#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database_vulnerability_assessment_rule_baseline.html#update MssqlDatabaseVulnerabilityAssessmentRuleBaseline#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database_vulnerability_assessment_rule_baseline.html azurerm_mssql_database_vulnerability_assessment_rule_baseline}.
 *
 * @stability stable
 */
export declare class MssqlDatabaseVulnerabilityAssessmentRuleBaseline extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database_vulnerability_assessment_rule_baseline.html azurerm_mssql_database_vulnerability_assessment_rule_baseline} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MssqlDatabaseVulnerabilityAssessmentRuleBaselineConfig);
    private _baselineName?;
    /**
     * @stability stable
     */
    get baselineName(): string;
    /**
     * @stability stable
     */
    set baselineName(value: string);
    /**
     * @stability stable
     */
    resetBaselineName(): void;
    /**
     * @stability stable
     */
    get baselineNameInput(): string | undefined;
    private _databaseName;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    get databaseNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _ruleId;
    /**
     * @stability stable
     */
    get ruleId(): string;
    /**
     * @stability stable
     */
    set ruleId(value: string);
    /**
     * @stability stable
     */
    get ruleIdInput(): string;
    private _serverVulnerabilityAssessmentId;
    /**
     * @stability stable
     */
    get serverVulnerabilityAssessmentId(): string;
    /**
     * @stability stable
     */
    set serverVulnerabilityAssessmentId(value: string);
    /**
     * @stability stable
     */
    get serverVulnerabilityAssessmentIdInput(): string;
    private _baselineResult;
    /**
     * @stability stable
     */
    get baselineResult(): MssqlDatabaseVulnerabilityAssessmentRuleBaselineBaselineResult[];
    /**
     * @stability stable
     */
    set baselineResult(value: MssqlDatabaseVulnerabilityAssessmentRuleBaselineBaselineResult[]);
    /**
     * @stability stable
     */
    get baselineResultInput(): MssqlDatabaseVulnerabilityAssessmentRuleBaselineBaselineResult[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): MssqlDatabaseVulnerabilityAssessmentRuleBaselineTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: MssqlDatabaseVulnerabilityAssessmentRuleBaselineTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): MssqlDatabaseVulnerabilityAssessmentRuleBaselineTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
