import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SecurityCenterServerVulnerabilityAssessmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_server_vulnerability_assessment.html#hybrid_machine_id SecurityCenterServerVulnerabilityAssessment#hybrid_machine_id}.
     *
     * @stability stable
     */
    readonly hybridMachineId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_server_vulnerability_assessment.html#virtual_machine_id SecurityCenterServerVulnerabilityAssessment#virtual_machine_id}.
     *
     * @stability stable
     */
    readonly virtualMachineId?: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_server_vulnerability_assessment.html#timeouts SecurityCenterServerVulnerabilityAssessment#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: SecurityCenterServerVulnerabilityAssessmentTimeouts;
}
/**
 * @stability stable
 */
export interface SecurityCenterServerVulnerabilityAssessmentTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_server_vulnerability_assessment.html#create SecurityCenterServerVulnerabilityAssessment#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_server_vulnerability_assessment.html#delete SecurityCenterServerVulnerabilityAssessment#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_server_vulnerability_assessment.html#read SecurityCenterServerVulnerabilityAssessment#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_server_vulnerability_assessment.html#update SecurityCenterServerVulnerabilityAssessment#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_server_vulnerability_assessment.html azurerm_security_center_server_vulnerability_assessment}.
 *
 * @stability stable
 */
export declare class SecurityCenterServerVulnerabilityAssessment extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/security_center_server_vulnerability_assessment.html azurerm_security_center_server_vulnerability_assessment} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: SecurityCenterServerVulnerabilityAssessmentConfig);
    private _hybridMachineId?;
    /**
     * @stability stable
     */
    get hybridMachineId(): string;
    /**
     * @stability stable
     */
    set hybridMachineId(value: string);
    /**
     * @stability stable
     */
    resetHybridMachineId(): void;
    /**
     * @stability stable
     */
    get hybridMachineIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _virtualMachineId?;
    /**
     * @stability stable
     */
    get virtualMachineId(): string;
    /**
     * @stability stable
     */
    set virtualMachineId(value: string);
    /**
     * @stability stable
     */
    resetVirtualMachineId(): void;
    /**
     * @stability stable
     */
    get virtualMachineIdInput(): string | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): SecurityCenterServerVulnerabilityAssessmentTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: SecurityCenterServerVulnerabilityAssessmentTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): SecurityCenterServerVulnerabilityAssessmentTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
